<%@ Language=VBScript %>
<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: error_dialog.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added modification history.
'	7/26/99		PSun		Incorporated termination (moved code from
'							error_submit.asp in).
'	7/30/99		PSun		Changed timeout handling.
'	8/18/99		PSun		Added SessionID to window names.
'	8/25/99		PSun		Code cleanup.
'
%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput

	Dim bContinue
	bContinue = true

	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
		
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next

		If Session("Alive") <> true Then
			%>
				<script language='JavaScript'>
					window.open('session_timeout.asp','TestManager<%=Session("SessionID")%>');
					window.close();
				</script>
			<%			
			bContinue = false
		End If
	End Sub

	Sub SetSessionVariables	
		' requires:
		' modifies:
		' effects:		
		On Error Resume Next
	End Sub

	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Handles the button input and sets the system to reset
		'			to the proper state.
		If Request.QueryString("OK") = "True" Then
			Session("Retry") = Session("Button")
			Session("Error") = Empty
			Session("DlgType") = Empty
			Session("Button") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp", "TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
		End If
	End Sub
	
	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the error dialog.
		%>
		<html>
		<head>
			<title>
				<%=Session("DlgType")%>
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 10pt}
			</style>
			<script language='JavaScript'>
				window.blur();
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<form name='ErrorForm' method='POST' action='error_dialog.asp?OK=True'>
			<%
			WriteButtonDialog Session("DlgType"), _
							  Session("Error"), "Retry", _
							  Session("Button"), ""
			%>
			</form>
		</body>
		</html>

		<script language='JavaScript'>
			// Calculate window size and resize the window
			var x;
			var y;
			if (window.navigator.appName == 'Netscape') {
				x = document.width;
				y = document.height;		
			} else {
				x = document.ErrorForm.offsetWidth + 46;
				y = document.ErrorForm.offsetHeight + 64;
			}
			window.resizeTo(x,y);
			window.focus();

			// Calculate window position and center the window.		
			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			}
			window.moveTo(xOffset,yOffset);
				
		</script>
		<%
	End Sub
%>	