<%@ language = VBScript %>
<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: overwrite_dialog.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added modification history.
'	6/22/99		PSun		Changed exit target.
'							Added standard dialog processing structure.
'							Added session timeout check.
'	6/28/99		PSun		Fixed misalignment of No button on Unix IE5.
'	7/30/99		PSun		Changed timeout handling.
'	8/18/99		PSun		Added SessionID to window names.
'	8/23/99		PSun		Modified functionality to match windows 
'							version.
'	8/25/99		PSun		Code cleanup.
'	12/1/99		PSun		Changed timeout handling.
'
%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next

	Dim bContinue
	bContinue = true

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput

	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
		
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next

		If Session("Alive") <> true Then
			%>
				<script language='JavaScript'>
					window.open('session_timeout.asp','TestManager<%=Request.QueryString("SessionID")%>');
					window.close();
				</script>
			<%
			bContinue = false
		End If	
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: 
		' effects:	Sets session variables needed for this dialog.
		On Error Resume Next
	End Sub
	
	Sub ProcessInput
		On Error Resume Next
		' requires:
		' modifies: Session variables "SubmitLogInfo", and "SubmitResult"
		' effects:  Decides next state based on input.

		If Request.QueryString("Yes") = "True" Then
			Session("SubmitLogInfo") = true
			%>
			<script language='JavaScript'>
				window.open("default.asp","TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
		End If

		If Request.QueryString("No") = "True" Then
			Session("SubmitLogInfo") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp","TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
		End If

		If Request.QueryString("Cancel") = "True" Then
			Session("SubmitLogInfo") = Empty
			Session("SubmitResult") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp","TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
		End If
	End Sub
	
	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the overwrite dialog.
		%>
		<html>
		<head>
			<title>
				Rational TestManager
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 10pt} 
			</style>
			<script language='JavaScript'>
				window.focus();
				
				function Overwrite() {
					window.open("overwrite_dialog.asp?Yes=True" + 
								"&SessionID=<%=Session("SessionID")%>",
								"OverwriteDialog<%=Session("SessionID")%>");
				}

				function DontOverwrite() {
					window.open("overwrite_dialog.asp?No=True" + 
								"&SessionID=<%=Session("SessionID")%>",
								"OverwriteDialog<%=Session("SessionID")%>");
				}

				function CancelWrite() {
					window.open("overwrite_dialog.asp?Cancel=True" +
								"&SessionID=<%=Session("SessionID")%>",
								"OverwriteDialog<%=Session("SessionID")%>");
				}
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<center>
			<form name='OverwriteForm' method='POST' 
				  action='overwrite_dialog.asp?SessionID=<%=Session("SessionID")%>'>
			<table cellspacing='0' cellpadding='0' border='0'>
			<tr>	
				<td align='center'>
				<font face='Arial, Helvetica' size='-1'>
					The specified Log already exists. Do you want to overwrite?
				</td>
			</tr>
			<tr>
				<td align='center' bgcolor='#c0c0c0'>
				<table cellspacing='0' cellpadding='5' border='0'>
				<tr>
				<br>
					<td align='left' bgcolor='#c0c0c0'>
					<font face='Arial, Helvetica' size='-1'>  
					<input type='Button' name='Yes' value='   Yes   ' onClick='Overwrite();'>
					&nbsp; 
					</td>
					<td align='left' bgcolor='#c0c0c0'>
					<font face='Arial, Helvetica' size='-1'> 
					<input type='Button' name='No' value='    No    ' onClick='DontOverwrite();'>
					&nbsp;
					</td>
					<td align='left' bgcolor='#c0c0c0'>
					<font face='Arial, Helvetica' size='-1'> 
					<input type='Button' name='Cancel' value='Cancel' onClick='CancelWrite();'>
					&nbsp;
					</td>
				</tr>
				</table>
				</td>
			</tr>		
			</table>
			</form>
			</center>
		</body>
		</html>

		<script language='JavaScript'>
			// Calculate window size and resize the window.
			var x;
			var y;
			//if (window.navigator.appName == 'Netscape') {
			//	x = document.width;
			//	y = document.height;
			//} else {
				x = document.OverwriteForm.offsetWidth + 49;
				y = document.OverwriteForm.offsetHeight + 60;
			//}		
			window.resizeTo(x,y);
			window.focus();
			
			// Calculate window position and center the window.	
			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			}
			window.moveTo(xOffset,yOffset);
		</script>
		<%
	End Sub
%>