<%
' Copyright 1999-2001 Rational Software Corporation
'
'	File: preamble.inc
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added Modification History.
'							Added log info input check
'	6/22/99		PSun		Changed comment window handling.
'							Added note window handling.
'							Added error checking for MSXML.
'	6/23/99		PSun		Fixed problem with <p> being added to log.
'	7/1/99		PSun		Added line numbering.
'	7/9/99		PSun		Added additional error checking for MSXML.
'	7/15/99		PSun		Moved out SetResultAllPass and SetResultAllFail
'							to testmanager.inc
'							Changed result_submit.asp to record_result.asp.
'	8/18/99		PSun		Added SessionID to window names.
'	8/25/99		PSun		Code cleanup.
'	7/12/00		PSun		Fixed dialog to use ML data store.
'	12/19/00	PSun		Added code to cleanup test case selection on retry.
'	7/11/02         OMoroz		Changed "Comment" column name to " Result Details" 
'

Sub CheckUserInput
	' requires:
	' modifies: Session variables (almost all of them).
	' effects:  Resets session variables on error.
	On Error Resume Next

	If Session("Retry") = "Logon Again" Then
		Session("UserID") = Empty
		Session("Password") = Empty
		Session("Project") = Empty
		Session("Location") = Empty
		Session("Retry") = Empty
		Session("InRepoInfoState") = Empty
		Session("SubmitRepoInfo") = Empty
		Session("TMSServerPtr") = Empty
		Session("ScriptName") = Empty
		Session("TestCaseName") = Empty
		Session("TestCaseUID") = Empty
		Session("SubmitScriptName") = Empty
		Session("Data") = Empty
		Session("Build") = Empty
		Session("LogFolder") = Empty
		Session("Log") = Empty
		Session("SubmitLogInfo") = Empty
		Session("InLogInfoState") = Empty
		Session("InTestCaseSelectState") = Empty
	ElseIf Session("Retry") = "Select Another Test Case" Then
		Session("ScriptName") = Empty
		Session("TestCaseName") = Empty
		Session("Retry") = Empty
		Session("SubmitScriptName") = Empty
		Session("InTestCaseSelectState") = Empty
	ElseIf Session("Retry") = "Select Another Log" Then
		Session("Build") = Empty
		Session("LogFolder") = Empty
		Session("Log") = Empty
		Session("SubmitLogInfo") = Empty
		Session("InLogInfoState") = Empty
		Session("Retry") = Empty
	ElseIf Session("Retry") = "Write to Another Log" Then
		Session("Build") = Empty
		Session("LogFolder") = Empty
		Session("Log") = Empty
		Session("SubmitLogInfo") = Empty
		Session("Retry") = Empty		
	End If
End Sub

Sub LoadScript
	' requires: A valid (logged in) connection to the data store as well as
	'			a valid script name.
	' modifies: Session("Data")  
	' effects:	Parses and loads the manual script specified by 
	'			Session("ScriptName") into a 2D data array stored as 
	'			Session("Data")
    On Error Resume Next

	Dim TMSServerPtr
	Dim TMSTestScriptServerPtr
	Dim TMSScriptPtr
	Dim strName
	Dim intCounter
	Dim DataArray()
	Dim strType
	Dim strText
	Dim strNote
	Dim strExpectedResultText 
	Dim strExpResultFile 
	
	strName = Session("ScriptName")
	Set TMSServerPtr = Session("TMSServerPtr")
	If Err.Number <> 0 then	
		Exit Sub
	End if	
	Set TMSTestScriptServerPtr = TMSServerPtr.TestScriptServer
	If Err.Number <> 0 then	
		Exit Sub
	End if	
	Set TMSScriptPtr = TMSTestScriptServerPtr.GetScriptByName(strName)
	If Err.Number <> 0 then	
		Exit Sub
	End if
	
	For intCounter = 1 to TMSScriptPtr.GetManualStepCount
		
		ReDim Preserve DataArray(8, intCounter)
		strType = TMSScriptPtr.GetManualStepTypeAt(intCounter)
		If Err.Number <> 0 then	
			Exit Sub
		End if

		strNote = TMSScriptPtr.GetManualStepNoteAt(intCounter)
		If Err.Number <> 0 then	
			Exit Sub
		End if

		strText = TMSScriptPtr.GetManualStepTextAt(intCounter)
		
		strExpectedResultText = TMSScriptPtr.GetManualStepExpectedResultAt(intCounter)
		strExpResultFile = TMSScriptPtr.GetManualStepExpectedFileAt(intCounter)


		If Err.Number <> 0 then	
			Exit Sub
		End if

		If strType = "Step" Or strType = "VP" Then	
			' Store type information
			DataArray(0, intCounter) = strType
			' Store the description
			DataArray(1, intCounter) = strText
			' Store the note
			DataArray(2, intCounter) = strNote
			' Store the Expected Result

			DataArray(5, intCounter) = strExpectedResultText
			' Store the Expected Result File
			DataArray(6, intCounter) = strExpResultFile


			DataArray(4, intCounter) = ""
			DataArray(7, intCounter) = ""
			
		End If		
	Next
	
	Session("Data") = DataArray	
	If Err.Number <> 0 then	
		Exit Sub
	End if
End Sub


Sub DisplayTableHeader
	' requires: 
	' modifies: 
	' effects:  Outputs HTML that draws the header for the script table.
	On Error Resume Next

    Dim boolNoGraphics
    Dim strUserID

    strUserID = Session("UserID")
    boolNoGraphics = CBool(Request.Cookies(strUserID)("NoGraphics"))

	' Comment checking and note marking functions.
%>	<script language='JavaScript'>
		top.winResultDetails = null;
		var bResultDetails = false;
		var index;
		var interval = 300;
		var intervalID = window.setInterval("onResultDetailsWindowClose(index, bResultDetails)",interval);

		function onResultDetailsWindowClose(index, bResultDetails) {
			if (top.winResultDetails != null) {
				if (top.winResultDetails.closed) {
					if (bResultDetails == false) {
						UnMarkResultDetails(index);
					}
					return;
				}
			}
			return;
		}


		

		function OpenFile(strFilePath) {
			
			window.open(strFilePath,"_blank","toolbar=no,resizable=yes,height=580,width=780");
			
		}
			

		function UnMarkResultDetails(index) { 
<%	If boolNoGraphics Then %>
			document.ScriptForm["ResultDetails"+index].checked = false;
<% 	Else %>
			var img = document.images["img" + index];
			img.src = "./images/nocomment.jpg";
<% 	End If %>
			return;
		}

		function MarkResultDetails(index) { 
<%	If boolNoGraphics Then %>
			document.ScriptForm["ResultDetails"+index].checked = true;
<% 	Else %>
			var img = document.images["img" + index]
			img.src = "./images/bmp00009.jpg"
<%	End If %>
			return;
		}

		function MarkNote(index) {
			document.ScriptForm["Note"+index].checked = true;
		}


		
	</script><%
    response.write 	vbTab+"<form method='POST' name='ScriptForm' "+_ 
							"action='record_result.asp'>"+vbCrLf+_
					vbTab+"<table border='1' frame='border' cellspacing='1' "+_
							"cellpadding='1'>"+vbCrLf+_
					vbTab+"<tr bgcolor='#c0c0c0'>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
  					vbTab+vbTab+vbTab+"&nbsp;&nbsp;&nbsp;&nbsp;"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
  					vbTab+vbTab+vbTab+"<b>Type</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
					vbTab+vbTab+vbTab+"<b>Note</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
					vbTab+vbTab+vbTab+"<b>Description</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_

					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
					vbTab+vbTab+vbTab+"<b>Expected Result</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_


					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
					vbTab+vbTab+vbTab+"<b>Expected Result File</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_




					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
					vbTab+vbTab+vbTab+"<b>Result</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+vbTab+"<td align='center'>"+vbCrLf+_
					vbTab+vbTab+vbTab+"<b> Result Details</b>"+vbCrLf+_
					vbTab+vbTab+"</td>"+vbCrLf+_
					vbTab+"</tr>"+vbCrLf
End Sub

Sub DisplayTableFooter
	' requires: 
	' modifies: 
	' effects:  Outputs HTML that draws the footer for the script table.
	On Error Resume Next
	
    response.write	vbTab+"</table>"+vbCrLf+_
					vbTab+"</form>"+vbCrLf

End Sub

Function ConvertCrLftoP (strText)
	' requires:
	' modifies:
	' effects:  Converts CrLf's in the string strText and replaces it with
	'			paragraph breaks.
	On Error Resume Next
 
	Dim strResultText
	Dim intIndex
	Dim intLen

	intIndex = InStr(strText, vbNewLine)		
	strResultText = ""

	While intIndex <> 0
		strResultText = strResultText + Left(strText, intIndex - 1) + "<p>"
		intLen = Len(strText)
		strText = Right(strText, intLen - intIndex)
		intIndex = InStr(strText, vbCrLf)			
	Wend
	
	strResultText = strResultText + strText

	ConvertCrLftoP = strResultText

End Function
	



Sub DisplayScript
	' requires: Session("Data") to be a valid manual script data array.
	' modifies: 
	' effects:	Generates the HTML to display the script specified by 
	'			Session("Data").
	On Error Resume Next
	
    Dim DataArray
    Dim iCount
    Dim strNodeName
    Dim strNote
    Dim strDescription
    Dim strExpectedResult
    Dim strExpectedResultFile
    Dim strResultDetails
    Dim strResultDetailsFile
    Dim strIndex
    Dim strColor
    Dim strResult
    Dim strUserID
    Dim boolVPOnly
    Dim boolNoGraphics
    Dim strExpectedResultFileTarget

    DataArray = Session("Data")
    strUserID = Session("UserID")
    boolVPOnly = CBool(Request.Cookies(strUserID)("VPOnly"))
    boolNoGraphics = CBool(Request.Cookies(strUserID)("NoGraphics"))

	' Generate the header.
    DisplayTableHeader

    For iCount = 1 to UBound(DataArray,2)
		strIndex = CStr(iCount)

		' Generate type infomation
		strNodeName = DataArray(0, iCount)

		If strNodeName = "Step" And boolVPOnly Then
			' Do nothing
		Else
			response.write	vbTab+"<tr>"+vbCrLf+_
							vbTab+vbTab+"<td align='center' bgcolor='#c0c0c0'>"+vbCrLf+_
  							vbTab+vbTab+vbTab+"<b>"+strIndex+"</b>"+vbCrLf+_
							vbTab+vbTab+"</td>"+vbCrLf+_
							vbTab+vbTab+"<td align='center'>"+vbCrLf

			If strNodeName = "Step" Then
				If boolNoGraphics Then
					response.write	vbTab+vbTab+vbTab+"S"	
				Else
					response.write	vbTab+vbTab+vbTab+"<img src='./images/step.jpg'>"+vbCrLf
				End If
			Else
				If boolNoGraphics Then
					response.write	vbTab+vbTab+vbTab+"VP"	
				Else
					response.write	vbTab+vbTab+vbTab+"<img src='./images/vp.jpg'>"+vbCrLf
				End If
				strColor = "#3333ff"
			End If
			response.write 	vbTab+vbTab+"</td>"+vbCrLf

			' Extract and output the note
			strNote = DataArray(2, iCount)
	
			If strNote <> "" Then
				Session("Note" + strIndex) = strNote
				response.write	vbTab+vbTab+"<td align='center'>"+vbCrLf+_
								vbTab+vbTab+vbTab+"<a border='0' href='#' onClick="+chr(34)+_
								"top.winNote = window.open('note.asp?value=" + strIndex +_
								"','note"+Session("SessionID")+"', 'width=370,height=355,resizable=yes')"+_
								chr(34)+">"+vbCrLf
				If boolNoGraphics Then
					response.write	vbTab+vbTab+vbTab+"<input type='checkbox' name='Note"+_
									strIndex+"' checked onClick='MarkNote("+strIndex+");'>"+vbCrLf		
				else
					response.write	vbTab+vbTab+vbTab+"<img src='./images/bmp00007.jpg'>"
				End If
				response.write	"</a>"+vbCrLf+_
								vbTab+vbTab+"</td>"+vbCrLf
			Else
				response.write	vbTab+vbTab+"<td align='center'>"+vbCrLf+_
								vbTab+vbTab+"</td>"+vbCrLf
			End If

			' Extract and output the description
			strDescription = DataArray(1, iCount)
			strDescription = ConvertCrLftoP(strDescription)

			response.write	vbTab+vbTab+"<td align='left'>"+vbCrLf+_
							vbTab+vbTab+"<font color='"+strColor+"'>"+vbCrLf+_
							vbTab+vbTab+vbTab+strDescription+vbCrLf+_
							vbTab+vbTab+"</font>"+vbCrLf+_
							vbTab+vbTab+"</td>"+vbCrLf
			strColor = "#000000"



			' Extract and output the Expected Result
			strExpectedResult = DataArray(5, iCount)
			strExpectedResult = ConvertCrLftoP(strExpectedResult)

			response.write	vbTab+vbTab+"<td align='left'>"+vbCrLf+_
							vbTab+vbTab+"<font color='"+strColor+"'>"+vbCrLf+_
							vbTab+vbTab+vbTab+strExpectedResult+vbCrLf+_
							vbTab+vbTab+"</font>"+vbCrLf+_
							vbTab+vbTab+"</td>"+vbCrLf
			strColor = "#000000"


			' Extract and output the Expected Result File
			strExpectedResultFile = DataArray(6, iCount)
			
			' If it's UNC file name add file:/// at the beginning
			If Mid(strExpectedResultFile,1,2) = "\\" Then
				
				strExpectedResultFileTarget = Replace(strExpectedResultFile, "\", "/")
				strExpectedResultFileTarget = "file:///" + strExpectedResultFileTarget
				
			Else	
				strExpectedResultFileTarget = Replace(strExpectedResultFile, "\", "/")
				
						
			End If
			
			If BrowserIsMSIE() Then
			response.write	vbTab+vbTab+"<td align='left'>"+vbCrLf+_
							vbTab+vbTab+"<font color='"+strColor+"'>"+vbCrLf+_
							vbTab+vbTab+vbTab+"<a href='#' OnClick = 'OpenFile(" + chr(34) + strExpectedResultFileTarget + chr(34) + ");' >" + strExpectedResultFile + "</a>"  +vbCrLf
							vbTab+vbTab+"</font>"+vbCrLf+_
							vbTab+vbTab+"</td>"+vbCrLf
			
			'Don't display link for Netscape browser, can't open files
			Else
							response.write	vbTab+vbTab+"<td align='left'>"+vbCrLf+_
							vbTab+vbTab+"<font color='"+strColor+"'>"+vbCrLf+_
							vbTab+vbTab+vbTab+strExpectedResultFile+vbCrLf+_
							vbTab+vbTab+"</font>"+vbCrLf+_
							vbTab+vbTab+"</td>"+vbCrLf

			End If				
			
			
			strColor = "#000000"


			' Output the result choices
			strResult = DataArray(3, iCount)

			If strNodeName = "VP" Then
				response.write	vbTab+vbTab+"<td align='center'>"+vbCrLf+_
								vbTab+vbTab+vbTab+"<select size='1' name='Result"+strIndex+"'>"+vbCrLf
				If strResult = "None" Then
					response.write  vbTab+vbTab+vbTab+vbTab+"<option selected value='None'>< None ></option>"+vbCrLf
				Else
					response.write  vbTab+vbTab+vbTab+vbTab+"<option value='None'>< None ></option>"+vbCrLf
				End If
	
				If strResult = "Pass" Then
					response.write	vbTab+vbTab+vbTab+vbTab+"<option selected value='Pass'>Pass</option>"+vbCrLf
				Else
					response.write	vbTab+vbTab+vbTab+vbTab+"<option value='Pass'>Pass</option>"+vbCrLf
				End If

				If strResult = "Fail" Then
					response.write	vbTab+vbTab+vbTab+vbTab+"<option selected value='Fail'>Fail</option>"+vbCrLf
				Else
					response.write	vbTab+vbTab+vbTab+vbTab+"<option value='Fail'>Fail</option>"+vbCrLf
				End If
				response.write	vbTab+vbTab+vbTab+"</select>"+vbCrLf+_
								"</td>"+vbCrLf
			Else
				If strResult = "on" Then
					response.write	vbTab+vbTab+"<td align='center'>"+vbCrLf+_
									vbTab+vbTab+vbTab+"<input type='checkbox' checked name='Result"+_
									strIndex+"'>"+vbCrLf+_
									vbTab+vbTab+"</td>"+vbCrLf
				Else
					response.write	vbTab+vbTab+"<td align='center'>"+vbCrLf+_
									vbTab+vbTab+vbTab+"<input type='checkbox' name='Result"+_
									strIndex+"'>"+vbCrLf+_
									vbTab+vbTab+"</td>"+vbCrLf
				End If
			End If		

	
			strResultDetails = DataArray(4, iCount)
			Session("ResultDetails"+strIndex) = strResultDetails
			
			strResultDetailsFile = DataArray(7, iCount)
			Session("ResultDetailsFile"+strIndex) = strResultDetailsFile

			' Output the ResultDetails field	
			response.write	vbTab+vbTab+"<td align='center'>"+vbCrLf

			If strResultDetails = "" And strResultDetailsFile = ""  Then
				If boolNoGraphics Then
					response.write	vbTab+vbTab+vbTab+"<input type='checkbox' name='ResultDetails"+_
									strIndex+"' onClick="+chr(34)+_
									"index = "+strIndex+"; top.winResultDetails = window.open('ResultDetails.asp?value="+strIndex+_
									"', 'ResultDetails"+Session("SessionID")+"','width=370,height=355,resizable=yes');"+_
									"MarkResultDetails('" + strIndex + "');"+chr(34)+">"+vbCrLf
				Else
					response.write	vbTab+vbTab+vbTab+"<a border='0' href='#' onClick="+chr(34)+_
									"index = "+strIndex+"; top.winResultDetails = window.open('ResultDetails.asp?value="+strIndex+_
									"', 'ResultDetails"+Session("SessionID")+"','width=370,height=355,resizable=yes');"+_
									"MarkResultDetails('" + strIndex + "');"+_
									"return false;"+chr(34)+"'>"+vbCrLf+_
									vbTab+vbTab+vbTab+_
									"<img name='img" + strIndex + "' src='./images/nocomment.jpg'></a>"+vbCrLf
				End If
			Else
				If boolNoGraphics Then
					response.write	vbTab+vbTab+vbTab+"<input type='checkbox' name='ResultDetails"+_
									strIndex+"' onClick="+chr(34)+_
									"index = "+strIndex+"; win = window.open('ResultDetails.asp?value="+strIndex+_
									"', 'ResultDetails"+Session("SessionID")+"','width=370,height=355,resizable=yes');"+_
									"MarkResultDetails('" + strIndex + "');"+chr(34)+">"+vbCrLf
				Else
					response.write	vbTab+vbTab+vbTab+"<a border='0' href='#' onClick="+chr(34)+_
									"index = "+strIndex+"; win = window.open('ResultDetails.asp?value="+strIndex+_
									"', 'ResultDetails"+Session("SessionID")+"','width=370,height=355,resizable=yes');"+_
									"MarkResultDetails('" + strIndex + "');"+_
									"return false;"+chr(34)+"'>"+vbCrLf+_
									vbTab+vbTab+vbTab+_
									"<img name='img" + strIndex + "' src='./images/bmp00009.jpg'></a>"+vbCrLf
				End If
			End If
	
			response.write	vbTab+vbTab+"</td>"+vbCrlf+_
							vbTab+"</tr>"+vbCrLf
		End If
	Next

	' Generate the footer.
    DisplayTableFooter
End Sub
%>

