<%@ Language=VBScript %>
<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: prompt_log_info.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added modification history.
'	6/22/99		PSun		Added session timeout check.
'	6/28/99		PSun		Fixed misalignment of Help button on Unix IE5.
'	7/7/99		PSun		Moved select list generation functions to testmanager.inc
'	7/23/99		PSun		Changed getHelp() to call help file directly.
'	7/29/99		PSun		Changed getHelp() target window.
'	7/30/99		PSun		Changed timeout handling.
'	7/12/99		PSun		Modified help anchor.
'	8/18/99		PSun		Added SessionID to window names.
'	8/25/99		PSun		Code cleanup.
'	11/30/99	PSun		Changed timeout handling.
'   7/12/00		PSun		Fixed dialog to use ML data store.
'
'IBM Confidential 
	
'(c) Copyright IBM Corp. [2000], [2006]  All Rights Reserved.
'
'The source code for this program is not published or otherwise 
'divested of its trade secrets, irrespective of what has been 
'deposited with the U.S. Copyright Office.
' 



%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput

	Dim bContinue
	bContinue = true
	
	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
	
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next
		
		If Session("Alive") <> true Then
			%>
			<script language='JavaScript'>
				window.open('session_timeout.asp','TestManager<%=Request.QueryString("SessionID")%>');
				window.close();
			</script>
			<%			
			bContinue = false
		End If	
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: Session variables "Build", "LogFolder", and "Log"
		' effects:	Sets session variables needed for this dialog.
		On Error Resume Next
		
		If	Session("InLogInfoState") = Empty Then
			
			' Set variables from cookies
			Dim strUserID
			strUserID = Session("UserID")
			Session("Build") = Request.Cookies(strUserID)("Build")
			Session("LogFolder") = Request.Cookies(strUserID)("LogFolder")
						
			' Set variables from other input
			Session("Log") = Session("TestCaseName")
		End If
	End Sub
	
	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Handles input checking and storage.  Writes cookies and
		'           closes window if a exit state is reached.
		On Error Resume Next
		
		Dim bExist
		Dim strUserID
		strUserID = Session("UserID")

		' Close dialog if cancel is selected.
		If Request.QueryString("Cancel")="True" Then
			Session("SubmitResult") = Empty
			Session("Build") = Empty
			Session("LogFolder") = Empty
			Session("Log") = Empty
			Session("InLogInfoState") = Empty
			%>
			<script language='JavaScript'>
				window.close();
			</script>
			<%
			Exit Sub
		End If
		
		' If it is the first instantiation (blank build), just wait for input	
		If Request.Form("Build") = Empty And Session("InLogInfoState") = Empty Then
			Session("InLogInfoState") = true
		' If the build is empty and it is not the first instantiation of the 
		' dialog, then clear the LogFolder field as well.
		Elseif Request.Form("Build") = Empty And Session("InLogInfoState") = True Then
			Session("Build") = Empty
			Session("LogFolder") = Empty
		' Otherwise...
		Else
			Session("InLogInfoState") = true
			' Set the build if it has changed
			If Session("Build") <> Request.Form("Build") Then
				Session("Build") = Request.Form("Build")
			' Keep waiting for a valid response if the build exists, but the
			' log folder is not selected.
			ElseIf Request.Form("LogFolder") = "" Then
				Session("LogFolder") = Empty
			' Otherwise write the log folder and...
			Else
				Session("LogFolder") = Request.Form("LogFolder")
				' Check to see if there is a valid log.  If there is not, keep
				' prompting for a log name.  If there is, continue processing.
				IF Request.Form("Log") = "" Then

				ElseIf Len(Request.Form("Log")) > 40 Then
					
					Session("Log") = Mid (Request.Form("Log"), 1, 40)
					










				Else
					Session("Log") = Request.Form("Log")
					WriteCookies
					bExist = CheckLogExistance(Session("Build"), Session("LogFolder"), Session("Log"))
					If CheckError Then
						ErrorDialog "Log Selection Error", "Select Another Log"
						Session("InLogInfoState") = Empty
						%>
						<script language='JavaScript'>
							window.close();
						</script>		
						<%
						Exit Sub
					End If
				
					Session("InLogInfoState") = Empty
					' If the log exists, prompt to see if the user wants it
					' overwitten.  Otherwise, close window and move on to 
					' next state.
					If bExist Then
						%>
						<script language='JavaScript'>
							var iScreenW = screen.width;
							var iScreenH = screen.height;
							var winChild;

							if (window.navigator.appName == 'Netscape') {
								iScreenW = window.outerWidth/2 + window.screenX - 150;
								iScreenH = window.outerHeight/2 + window.screenY - 55;
							}
							
							winChild = window.open('','OverwriteDialog<%=Session("SessionID")%>','width=300,height=110,resizable=yes,left='
       											   +iScreenW+',top='+iScreenH+
       											   ',screenX='+iScreenW+',screenY='+iScreenH);
							self.focus();
							winChild.location.replace('overwrite_dialog.asp?SessionID=<%=Session("SessionID")%>');
							window.close();
						</script>
						<%
					Else
						Session("SubmitLogInfo") = true
						%>
						<script language='JavaScript'>
							window.open("default.asp", "TestManager<%=Session("SessionID")%>");
							window.close();
						</script>
						<%
					End If
				End If	
			End If					
		End If	
	End Sub		
	
	Sub WriteCookies
		' requires:
		' modifies: Cookies collection.
		' effects:  Writes savable state to a cookie identified by the UserID.  
		'			The expiration for the cookie is 2 years.
		On Error Resume Next
		
		Dim strUserID
		strUserID = Session("UserID")
		Response.Cookies(strUserID).expires = DateExpires(2,0,0)
		Response.Cookies(strUserID)("Build") = Session("Build")		
		Response.Cookies(strUserID)("LogFolder") = Session("LogFolder")	
		Response.Cookies(strUserID)("Log") = Session("Log")		
	End Sub
	
	Function CheckLogExistance(strBuild, strLogFolder, strLog)
		' requires:
		' modifies: 
		' effects:  Checks for the Log named by strLog in the build 
		'           identified by strBuildUID and the log folder identified
		'           by strLogFolder.  Returns true if it exists and false if
		'           it does not. 
		On Error Resume Next
		
		Dim TMSServerPtr
		Dim TMSBuildPtr
		Dim TMSLogFolderPtr
		Dim TMSAssetColPtr
		Dim intCounter
		Dim strName
		Dim bResult
		
		bResult = false
		' From the repository root, load the build and log folder.
		Set TMSServerPtr = Session("TMSServerPtr")
		If Err.Number <> 0 then
			Exit Function
		End if
		Set TMSBuildPtr = TMSServerPtr.GetBuildByName(strBuild)
		If Err.Number <> 0 then
			Exit Function
		End if
		Set TMSLogFolderPtr = TMSBuildPtr.GetLogFolder(strLogFolder)
		If Err.Number <> 0 then
			Exit Function
		End if
		
		' Get the log collection and loop through it looking for the log.
		Set TMSAssetColPtr = TMSLogFolderPtr.GetLogs
		If Err.Number <> 0 then
			Exit Function
		End if
			
		For intCounter = 1 TO TMSAssetColPtr.Count
			If Err.Number <> 0 then
				Exit Function
			End if
			strName = TMSAssetColPtr.Name(intCounter)
			If Err.Number <> 0 then
				Exit Function
			End if
			If strName = strLog Then
				bResult = true
			End If
		Next

		CheckLogExistance = bResult
	End Function

	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the log info dialog filling in appropriate 
		'			fields based on previous input.
		%>
		<html>
		<head>
			<title>
				Specify Log Information
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 9pt} 
			</style>
			<script language='JavaScript'>
				window.blur();
				
				function getHelp() {
					window.open('./help/help.asp?anchor=specifylog','TestManagerHelp');
				}
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<form id='LogForm' name='LogForm' method='POST' 
				  action='prompt_log_info.asp?SessionID=<%=Session("SessionID")%>'>
			<table cellspacing='0' cellpadding='0' border='0'>
			<tr>
				<td>
				<table border='0' cellspacing='0' cellpadding='5' width='100%'>
				<tr>
					<td align='left' nowrap bgcolor='#c0c0c0'>
						Build
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<%
					GenerateBuildSelectByAssetCol Session("TMSServerPtr"), _
											      Session("Build"), _
											      1, _
											      40 
					If CheckError Then
						ErrorDialog "Log Selection Error", "Select Another Log"			
						%>
						<script language='JavaScript'>
							window.close();
						</script>		
						<%
					End If
					%>
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
						Log Folder
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<%
					GenerateLogFolderSelectByAssetCol Session("TMSServerPtr"), _
													  Session("Build"), _
													  Session("LogFolder"), _
													  1, _
													  40
					If CheckError Then
						ErrorDialog "Log Selection Error", "Select Another Log"			
						%>
						<script language='JavaScript'>
							window.close();
						</script>		
						<%
					End If
					%>				
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<font face='Arial, Helvetica' size='-1'> 
						Log
					</font>
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<input type='text' size='43' name='Log' value='<%=Session("Log")%>'
						   style='font-family: Courier; font-size: 9pt'>
				</tr>
				<tr>
					<td align='right' bgcolor='#c0c0c0'>
					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='submit' name='Submit' value='    OK     '
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Cancel' value=' Cancel '
							   onClick='window.open("prompt_log_info.asp?Cancel=True" + 
													"&?SessionID=<%=Session("SessionID")%>", 
													"PromptLogInfo<%=Session("SessionID")%>");'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Help' value='   Help   '
							   onClick='getHelp();'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
					</tr>
					</table>
					</td>
				</tr>
				</table>
				</td>
			</tr>
			</table>
			</form>
		</body>
		</html>

		<script language='JavaScript'>
			// Calculate window size and resize the window	
			var x;
			var y;
			//if (window.navigator.appName == 'Netscape') {
			//	x = document.width;
			//	y = document.height;
			//} else {
				x = document.LogForm.Log.offsetWidth + 40;
				y = document.LogForm.offsetHeight + 60;
			//}
			window.resizeTo(x,y);
			window.focus();

			// Calculate window position and center the window.
			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			}
			window.moveTo(xOffset,yOffset);
		</script>
		<% 
	End Sub 
%>