<%@ language = VBScript %>
<%
' Copyright 1998, 1999 Rational Software Corporation
'
'	File: prompt_options.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added modification history.
'	6/22/99		PSun		Changed exit target.
'							Added session timeout check.
'	6/28/99		PSun		Fixed misalignment of Help button on Unix IE5.
'	7/15/99		PSun		Changed the way AllPass updates are handled.
'	7/29/99		PSun		Changed the getHelp() target window.
'	7/30/99		PSun		Added option to log incomplete steps as 
'							warnings.
'							Changed timeout functionality.
'	8/12/99		PSun		Changed wording on logging warning option.
'							Modified help anchor.
'	8/16/99		PSun		Removed "AllPass" option.
'	8/18/99		PSun		Added SessionID to window names.
'	8/25/99		PSun		Code cleanup.
'							Fixed "LogAsWarning" option not being saved.
'
%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next

	Dim bContinue
	bContinue = true

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput

	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
		
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next

		If Session("Alive") <> true Then
			%>
			<script language='JavaScript'>
				window.open('session_timeout.asp','TestManager<%=Session("SessionID")%>');
				window.close();
			</script>
			<%			
			bContinue = false
		End If
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: Session variables "NoGraphics", "VPOnly", "StepAsWarning",
		'			and Session.Timeout.
		' effects:	Sets session variables needed for this dialog.
		On Error Resume Next

		' Set Session variables from cookies only if this is a new instance
		' of the dialog.			
		If	Request.QueryString("Initialize") = "Yes" Then	
			' Set variables from cookies
			Dim strUserID
			strUserID = Session("UserID")
			Session("NoGraphics") = CBool(Request.Cookies(strUserID)("NoGraphics"))
			Session("VPOnly") = CBool(Request.Cookies(strUserID)("VPOnly"))
			Session("StepAsWarning") = CBool(Request.Cookies(strUserID)("StepAsWarning"))
			Session.Timeout = Request.Cookies(strUserID)("Timeout")
		End If
	End Sub

	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Handles input checking and storage.  Writes cookies and
		'           closes window if a exit state is reached.
		On Error Resume Next

		Dim intTimeout

		' Close window if cancel is selected.
		If Request.QueryString("Cancel") = "True" Then
			%>
			<script language='Javascript'>
				window.close();
			</script>
			<%
			Exit Sub
		End If		
		
		If Request.QueryString("OK") = "True" Then
			' Set some Session variables based on form input.
			If Request.Form("NoGraphics") = "on" Then
				Session("NoGraphics") = true
			Else
				Session("NoGraphics") = false
			End If

			If Request.Form("StepAsWarning") = "on" Then
				Session("StepAsWarning") = true
			Else
				Session("StepAsWarning") = false
			End If

			If Request.Form("VPOnly") = "on" Then
				Session("VPOnly") = true
			Else
				Session("VPOnly") = false
			End If
	
			' Timeout won't be set if it's greater than 1440 minutes (1 day) or 
			' less than 20 minutes. 
			intTimeout = Request.Form("Timeout")
			If intTimeout <> "" And IsNumeric(intTimeout) Then 
				If intTimeout > 1440 Then
					Session.Timeout = 1440
				ElseIf intTimeout < 20 Then
					Session.Timeout = 20
				Else
					Session.Timeout = Request.Form("Timeout")
				End If
			End If
				
			WriteCookies
			%>
			<script language='Javascript'>
				window.open("default.asp", "TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%	
		End If
	End Sub
	
	Sub WriteCookies
		' requires:
		' modifies: Cookies collection.
		' effects:  Writes savable state to a cookie identified by the UserID.  
		'			The expiration for the cookie is 2 years.
		On Error Resume Next
		  
		Dim strUserID
		strUserID = Session("UserID")
		Response.Cookies(strUserID).expires = DateExpires(2,0,0)
		Response.Cookies(strUserID)("NoGraphics") = Session("NoGraphics")		
		Response.Cookies(strUserID)("StepAsWarning") = Session("StepAsWarning")		
		Response.Cookies(strUserID)("VPOnly") = Session("VPOnly")		
		Response.Cookies(strUserID)("Timeout") = Session.Timeout		
	End Sub

	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the options dialog filling in appropriate 
		'			fields based on previous input.
		%>
		<html>
		<head>
			<title>
				Options
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 10pt} 
			</style>
			<script language='JavaScript'>
				window.blur();

				function getHelp() {
					window.open('./help/help.asp?anchor=options','TestManagerHelp');
				}
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<form name='OptionsForm' method='POST' action='prompt_options.asp?OK=True'>
			<table border='0' cellspacing='0' cellpadding='5' width='100%'>
			<tr>
				<td>
				<b>Display:</b>
				</td>
			</tr>
			<tr>
				<td align='left' nowrap bgcolor='#c0c0c0'>
				<input type='checkbox' name='NoGraphics' 
					<%If Session("NoGraphics") = true Then%>
					checked
					<%End If%>>		
					Show script without graphics
				</td>
			</tr>
			<tr>
				<td align='left' nowrap bgcolor='#c0c0c0'>
				<input type='checkbox' name='VPOnly' 
					<%If Session("VPOnly") = true Then %>
					checked
					<%End If%>>		
					Show only verification points
				</td>
			</tr>
			<tr>
				<td>
				<br>
				<b>Logging:</b>
				</td>
			</tr>
			<tr>
				<td align='left' nowrap bgcolor='#c0c0c0'>
				<input type='checkbox' name='StepAsWarning'		
					<%If Session("StepAsWarning") = true Then %>
					checked
					<%End If%>>		
					Log unchecked steps as warnings
				</td>
			</tr>
			<tr>
				<td>
				<br>
				<b>Usability:</b>
				</td>
			</tr>
			<tr>
				<td align='left' nowrap bgcolor='#c0c0c0'>
					Timeout interval in minutes (20-1440):&nbsp;
				<input type='text' name='Timeout' size='4' value=<%=Session.Timeout%>>
				</td>
			</tr>
			<tr>
					<td align='center' bgcolor='#c0c0c0'>
					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='submit' name='Submit' value='    OK     '
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp; 
						</td>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Cancel' value=' Cancel '
							   onClick='window.open("prompt_options.asp?Cancel=True","PromptOptions<%=Session("SessionID")%>");'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Help' value='   Help   '
							   onClick='getHelp();'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
					</tr>
					</table>
					</td>
			</tr>
		    </table>
			</form>
		</body>
		</html>

		<script language='JavaScript'>
			// Calculate window size and resize the window
			var x;
			var y;		
			//if (window.navigator.appName == 'Netscape') {
			//	x = document.width + 25;
			//	y = document.height - 10;
			//} else {
				x = document.OptionsForm.Submit.offsetWidth + 
					document.OptionsForm.Cancel.offsetWidth + 
					document.OptionsForm.Help.offsetWidth + 115;
				y = document.OptionsForm.offsetHeight + 55;
			//}
			window.resizeTo(x,y);
			window.focus();
			
			// Calculate window position and center the window.
			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			}
			window.moveTo(xOffset,yOffset);
		</script>
		<%
	End Sub
%>