<%@ Language=VBScript %>
<%
' /* IBM Confidential 
' *(c) Copyright IBM Corp. 2000 - 2006  All Rights Reserved.
' *The source code for this program is not published or otherwise 
' *divested of its trade secrets, irrespective of what has been 
' *deposited with the U.S. Copyright Office.
' */
'
'   File: prompt_repository_info.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Partially fixed invalid project bug.  
'							Added modification history.
'							Changed submit target.
'							Inlined cancel functionality.
'	6/22/99		PSun		Added code to distinguish next state.
'							Added session timeout check.
'	6/23/99		PSun		Added fix for password being redisplayed.
'	6/28/99		PSun		Fixed misalignment of Help button on Unix IE5.
'	7/9/99		PSun		Fixed password field being cleared problem.
'	7/16/99		PSun		Fixed problem with empty projects.
'	7/19/99		PSun		Fixed problem with default values not being 
'							submittable.
'	7/29/99		PSun		Change getHelp() target.
'	7/30/99		PSun		Changed timeout handling.
'							Changed cancel button functionality.
'	8/5/99		PSun		Major overhaul of login.  Added select for
'							Repository Path and changed input checking
'							logic.
'	8/11/99		PSun		Added toggle for select and input of repository
'							path.
'	8/12/99		PSun		Modified help anchor.
'							Removed DateExpires().
'	8/18/99		PSun		Redid repository path input.
'							Added SessionID to window names.
'	8/25/99		PSun		Code cleanup.
'	11/30/99	PSun		Changed timeout handling.
'   7/10/00		PSun		Fixed dialog to use ML data store.
'	12/15/00	PSun		Fixed LoadLocation.
'
%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next

	Dim bContinue
	bContinue = true

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput

	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput Session("UserID"), _
					  Session("Password"), _
					  Session("Project"), _
					  Session("Location")
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
		
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next

		If Session("Alive") <> true Then
			%>
				<script language='JavaScript'>
					window.open('session_timeout.asp','TestManager<%=Request.QueryString("SessionID")%>');
					window.close();
				</script>
			<%			
			bContinue = false
		End If	
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: Session variables "TMSServerPtr", "UserID", "Password", 
		'           "Project", and "Location."
		' effects:	Sets session variables needed for this dialog.  Resets
		'			the login by making sure that the application is logged
		'			out of the respository. 
		On Error Resume Next
			
		If Session("InRepoInfoState") = Empty Then

			' Make sure we're logged off.
			If Session("TMSServerPtr") <> Empty Then
				Dim TMSServerPtr
				Set TMSServerPtr = Session("TMSServerPtr")
				TMSServerPtr.Logout
			End If
			Session("TMSServerPtr") = Empty

			'Set variables from cookies
			Session("UserID") = Request.Cookies("Global")("UserID")
			Session("Password") = ""
			Session("Project") = Request.Cookies("Global")("Project")
			Session("Location") = Request.Cookies("Global")("Location")
		End If
	End Sub

	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Handles input checking and storage.  Writes cookies and
		'           closes window if a exit state is reached.
		On Error Resume Next

		Dim strUserID
		Dim strPassword
		Dim strProject
		Dim strLocation

		If Request.QueryString("Cancel") = "True" Then
			%>
			<script language='JavaScript'>
				window.open('log_off.asp','TestManager<%=Session("SessionID")%>');
				window.close();
			</script>
			<%
			Exit Sub
		End If

		' If first instance of the dialog, then wait for input.
		If Session("InRepoInfoState") <> True Then
			Session("InRepoInfoState") = True
		' Otherwise grab the input from the form and evaluate them.
		Else
			' Form items are truncated to desired lengths.	
			strUserID = Left(Request.Form("UserID"),30)
			strPassword = Left(Request.Form("Password"),30)
			strProject = Request.Form("Project")
						
			' Empty out password if username is empty.
			If strUserID = Empty Then
				Session("UserID") = ""
				Session("Password") = ""
			Else
				Session("UserID") = strUserID
				Session("Password") = strPassword
			End If
	
			' If the project select list is different from the stored value, 
			' then there was a change.  Update the location and exit the 
			' function.

			Session("Project") = strProject

			' If none of the needed fields are empty, Login to the
			' repository, write cookies and close the window.
			If Session("UserID") <> Empty And _
			   Session("Project") <> Empty Then

				Login Session("UserID"), Session("Password"), Session("Project")
				Session("InRepoInfoState") = Empty

				If Err.number <> 0 Then
					If CheckError Then
					
						If Err.Description = TMS_INVALID_USERNAME_OR_PASSWORD Then
							Err.Description = IDS_INVALID_USERNAME_OR_PASSWORD
												
						''ElseIf Err.Description = TMS_INVALID_SERVER Then
						  Else
							
							Err.Description = IDS_UNABLE_TO_CONNECT

						End If

					End If
						
				ErrorDialog "Login Error", "Logon Again"
				

				%>
				<script language='JavaScript'>
					window.close()
				</script>		
				<%
					Exit Sub
				End If
				
				WriteCookies
				Session("InRepoInfoState") = Empty
				Session("SubmitRepoInfo") = true
				Session("Password") = Empty
				%>	
				<script language='JavaScript'>
					window.open('default.asp?State=PromptScriptName','TestManager<%=Session("SessionID")%>');
					window.close();
				</script>	
				<%  
			End If
		End If
	End Sub

	Sub WriteCookies
		' requires:
		' modifies: Cookies collection.
		' effects:  Writes savable state to the "Global" cookie.  The 
		'			expiration for the cookie is 2 years.
		On Error Resume Next

		Response.Cookies("Global").expires = DateExpires(2,0,0)
		Response.Cookies("Global")("UserID") = Session("UserID")
		Response.Cookies("Global")("Project") = Session("Project")
		Response.Cookies("Global")("Location") = Session("Location")
	End Sub
	
	Sub Login(strUserID, strPassword, strProject)
		' requires:
		' modifies: Session variables "TMSServerPtr"
		' effects:  Logs into the repository using the username strUserID,
		'			the password strPassword, and the project strProject. 
		'           After a successful login, the server connection is 
		'           stored in a session variable.	
		On Error Resume Next
				
		Dim TMSServerPtr

		' Create the server object.
		Set TMSServerPtr = Server.CreateObject("TMSServer.TMSServer.1")
		If Err.Number <> 0 Then
			Exit Sub
		End if
		
		GetProjectLocation(strProject)
		If Err.Number <> 0 Then
			Exit Sub
		End if
		
		TMSServerPtr.Login False, Session("Location"), strUserID, strPassword, False		
		If Err.Number <> 0 Then
			Exit Sub
		End if
		Set Session("TMSServerPtr") = TMSServerPtr

	End Sub

	Sub GetProjectLocation(strProjectName)
		' requires: 
		' modifies: 
		' effects:  This function loads the project location based off of the
		'			name.

		On Error Resume Next

		Dim RAServerPtr
		Dim RAProjectsPtr
		Dim RAProjectPtr
		Dim intCounter
		Dim strName

		Set RAServerPtr = Server.CreateObject("RationalAdminServer.RAServer.1")
		If Err.Number <> 0 then
			Exit Sub
		End if
		
		Set RAProjectsPtr = RAServerPtr.GetProjects
		If Err.Number <> 0 then
			Exit Sub
		End if

		For intCounter = 1 to RAProjectsPtr.Count
			Set RAProjectPtr = RAProjectsPtr.Item(intCounter)
			strName = RAProjectPtr.Name
			If strName = strProjectName Then
				Session("Location") = RAProjectPtr.Path
			End If
		Next				
	End Sub

	
	Sub DisplayOutput(strUserID, strPassword, strProject, strLocation)
		' requires:
		' modifies: 
		' effects:	Generates the login dialog filling in appropriate 
		'           fields based on previous input.
		%>
		<html>
		<head>
			<title>
				Rational Test Login
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 9pt} 
			</style>
			<script language='JavaScript'>
				window.blur();		
						
				function getHelp() {
					window.open('./help/help.asp?anchor=login','TestManagerHelp');
				}
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<form name='LoginForm' method='POST' 
				  action='prompt_repository_info.asp?SessionID=<%=Session("SessionID")%>'>
			<table cellspacing='0' cellpadding='0' border='0'>
			<tr>
				<td>
				<table border='0' cellspacing='0' cellpadding='5' width='100%'>
				<tr>
					<td align='left' nowrap bgcolor='#c0c0c0'>
						User Name
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<input type='text' size='30' name='UserID' 
						   value='<%=strUserID%>'
		   				   style='font-family: Courier New; font-size: 10pt'>

					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
						Password
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<input type='password' size='30' name='Password' 
						   value='<%=strPassword%>'
						   style='font-family: Courier New; font-size: 10pt'>
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
						Project
					</td>
				</tr>
				<tr>	
					<td>
					<%
					GenerateProjectSelect strProject, _
										  1, _
										  40
					If CheckError Then
						ErrorDialog "Login Error", "Logon Again"			
						%>
						<script language='JavaScript'>
							window.close();
						</script>		
						<%
					End If 
					%>
					<br>
					</td>
				</tr>
				<tr>
					<td align='right' bgcolor='#c0c0c0'>
					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='submit' name='Submit' value='    OK     '
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp; 
						</td>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Cancel' value=' Cancel '
							   onClick='window.open("prompt_repository_info.asp?Cancel=True" +
													"&SessionID=<%=Session("SessionID")%>",
													"PromptRepositoryInfo<%=Session("SessionID")%>");'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Help' value='   Help   '
							   onClick='getHelp();'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
					</tr>
					</table>
					</td>
				</tr>
				</table>
				</td>
			</tr>
			</table>
			</form>
		</body>

		<script language='JavaScript'>
			// Calculate window size and resize the window
			var x;
			var y;	
			//if (window.navigator.appName == 'Netscape') {
				//x = document.LoginForm.Project.offsetWidth + 42;
				//y = document.LoginForm.offsetHeight + 56;
			//} else {
				x = document.LoginForm.Project.offsetWidth + 42;
				y = document.LoginForm.offsetHeight + 56;
			//}
			window.resizeTo(x,y)
			window.focus();
			
			// Calculate window position and center the window.
			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			 }
			window.moveTo(xOffset,yOffset);
		</script>
		<%
	End Sub
%>
		</html>
