<%@ Language=VBScript %>
<%
' Copyright 1998, 1999, 2000 Rational Software Corporation
'
'	File: prompt_script_name.asp
'
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Cleaned up code.  
'							Added modification history.
'							Changed submit and cancel target.
'	6/22/99		PSun		Added session timeout check.
'	6/24/99		PSun		Changed the size of the script list textarea
'	6/28/99		PSun		Fixed misalignment of Help button on Unix IE5.
'	7/26/99		PSun		Fixed problem with help causing a javascript error.
'	7/29/99		PSun		Changed getHelp() target window.
'	7/30/99		PSun		Changed timeout handling.
'	8/12/99		PSun		Changed help anchor.
'	8/18/99		PSun		Added SessionID to window names.
'	8/23/99		PSun		Added code to handle multi-state cancel.
'	8/25/99		PSun		Code cleanup.
'	11/30/99	PSun		Changed timeout handling.
'	7/12/00		PSun		Fixed dialog to use ML data store.
'
%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next
	
	Dim bContinue
	Dim strCancel
	strCancel = ""
	bContinue = true

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput
	
	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
		
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next
		
		If Session("Alive") <> true Then
			%>
				<script language='JavaScript'>
					window.open('session_timeout.asp','TestManager<%=Request.QueryString("SessionID")%>');
					window.close();
				</script>
			<%
			bContinue = false
		End If
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: strCancel
		' effects:	Sets strCancel to cancel to the right state.
		On Error Resume Next
		
		If Session("BackToDisplay") = true Then
			strCancel = "Display"
		Else
			strCancel = "Login"
		End If
	End Sub
	
	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Handles input checking and storage.  Writes cookies and
		'           closes window if a exit state is reached.
		On Error Resume Next
	
		' Pick the right cancel state.
		If Request.QueryString("Cancel") = "Login" Then			
			Session("SubmitRepoInfo") = Empty
			Session("UserID") = Empty
			Session("Password") = Empty
			Session("Project") = Empty
			Session("Location") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp", "TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
			Exit Sub
		ElseIf Request.QueryString("Cancel") = "Display" Then
			Session("BackToDisplay") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp", "TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
			Exit Sub
		End If

		' Exit if a script is selected.
		If Request.Form("ScriptNameList") <> "" Then
			Session("ScriptName") = Request.Form("ScriptNameList")
			Session("DataLoaded") = Empty
			Session("SubmitScriptName") = true
			%>
			<script language='JavaScript'>
				window.open("default.asp","TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
			Exit Sub
		End If
	End Sub

	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the script name dialog filling in appropriate 
		'			fields based on previous input.
		%>
		<html>
		<head>
			<title>
				Select Script
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 9pt} 
			</style>
			<script language='JavaScript'>
				window.blur();

				function getHelp() {
					window.open('./help/help.asp?anchor=selectscript','TestManagerHelp');
				}
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<font face='Arial, Helvetica' size='-1'>
			<form name='ScriptNameForm' method='POST' 
				  action='prompt_script_name.asp?SessionID=<%=Session("SessionID")%>'>
			<table cellspacing='0' cellpadding='0' border='0'>
			<tr>
				<td>
				<table border='0' cellspacing='0' cellpadding='5' width='100%'>
				<tr>
					<td align='left' nowrap bgcolor='#c0c0c0'>
					<font face='Arial, Helvetica' size='-1'>
						Script Name
					</font>
					</td>
				</tr>
				<tr>
					<td align='left' bgcolor='#c0c0c0'>
					<%	
					GenerateScriptNameSelectByQuery Session("TMSServerPtr"), _
													Session("ScriptName"), _
													15, _
													40
					If CheckError Then
						ErrorDialog "Login Error", "Logon Again"			
						%>
						<script language='JavaScript'>
							window.close();
						</script>		
						<%
					End If 
					%>
					</td>
				</tr>
				<tr>
					<td align='right' bgcolor='#c0c0c0'>
					<table cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td bgcolor='#c0c0c0' align='left'>
						<input type='Submit' name='Submit' value='    OK     '
							   style='font-family: arial; font-size: 9pt'> 
						&nbsp;
						</td>
						<td bgcolor='#c0c0c0' align='left'>
						<input type='button' name='Cancel' value=' Cancel '
							   onclick='window.open("prompt_script_name.asp?Cancel=<%=strCancel%>"+
													"&SessionID=<%=Session("SessionID")%>",
													"PromptScriptName<%=Session("SessionID")%>");'
							   style='font-family: arial; font-size: 9pt'> 
						&nbsp;
						</td>

						<td align='left' bgcolor='#c0c0c0'>
						<input type='button' name='Help' value='   Help   '
							   onClick='getHelp();'
							   style='font-family: Arial; font-size: 9pt'>
						&nbsp;
						</td>
					</tr>
					</table>
					</td>
				</tr>
				</table>
				</td>
			</tr>
		</table>
		</form>
		</font>
		</body>
		</html>

		<script language='JavaScript'>
			// Calculate window size and resize the window
			var x;
			var y;
			//if (window.navigator.appName == 'Netscape') {
			//	x = document.width;
			//	y = document.height;
			//} else {
				x = document.ScriptNameForm.ScriptNameList.offsetWidth + 40;
				y = document.ScriptNameForm.offsetHeight + 60;
			//}
			window.resizeTo(x,y);
			window.focus();

			// Calculate window position and center the window.
			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			}
			window.moveTo(xOffset,yOffset);
		</script>
		<%
	End Sub
%>