<%@ Language=VBScript %>
<%
' IBM Confidential 
' (c) Copyright IBM Corp. [2000], [2005]  All Rights Reserved.
'   The source code for this program is not published or otherwise 
'   divested of its trade secrets, irrespective of what has been 
'   deposited with the U.S. Copyright Office.
' 
'

'
'	File: prompt_testcase_name.asp
'
'
'	Modification History:
'	
'	Date		Who			What
'	12/18/00	PSun			Initial Version
'	12/19/00	PSun			Added expansion storing code
'	3/1/01		PSun			Added collapse code.		
'
%>
<!--#include file="./utilities/all.inc"-->
<%
	On Error Resume Next
	
	Dim bContinue
	Dim strCancel
	strCancel = ""
	bContinue = true
	
	
	Dim strTest

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput
	
	InitializeState
	If bContinue Then
		ProcessInput
		DisplayOutput
	End If
	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out and
		'			sets session or script variables needed to properly 
		'			process.
		On Error Resume Next
				
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next
		
		If Session("Alive") <> true Then
			%>
				<script language='JavaScript'>
					window.open('session_timeout.asp','TestManager<%=Request.QueryString("SessionID")%>');
					window.close();
				</script>
			<%
			bContinue = false
		End If
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: strCancel
		' effects:	Sets strCancel to cancel to the right state.
		On Error Resume Next
		
		If Session("BackToDisplay") = true Then
			strCancel = "Display"
		Else
			strCancel = "Login"
		End If

		If Session("InTestCaseSelectState") <> True Then
			ReDim ExpandedTestPlans(0)
			ReDim ExpandedTestCaseFolders(0)
			ReDim ExpandedTestCases(0)

			' Load expanded nodes from cookie??
			
			Session("ExpandedTestPlans") = ExpandedTestPlans
			Session("ExpandedTestCaseFolders") = ExpandedTestCaseFolders
			Session("ExpandedTestCases") = ExpandedTestCases
			Session("InTestCaseSelectState") = True
		End If
	End Sub
	
	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Handles input checking and storage.  Writes cookies and
		'           closes window if a exit state is reached.
		On Error Resume Next

		' Add expanded node
		Dim intExpandRow
		Dim strExpandedUID
		Dim intArraySize
		Dim strType
		Dim strTemp
		Dim strUID
		Dim strParentUID
		Dim TMSServerPtr
		Dim TMSTestCasePtr
		Dim TMSParentTestCasePtr
		
		Dim ExpandedTestPlans
		Dim ExpandedTestCaseFolders
		Dim ExpandedTestCases
				
		ExpandedTestPlans = Session("ExpandedTestPlans")
		ExpandedTestCaseFolders = Session("ExpandedTestCaseFolders")
		ExpandedTestCases = Session("ExpandedTestCases")
		
		Session("Type") = Request.QueryString("Type")
		Session("Expand") = Request.QueryString("Expand")
		Session("Collapse") = Request.QueryString("Collapse")

		Session("TestCaseUID") = Request.QueryString("TestCaseUID")
		Session("TestCaseType") = Request.QueryString("TestCaseType")
					
		strType = Request.QueryString("Type")
		strExpandedUID = Request.QueryString("Expand")
		strCollapseUID = Request.QueryString("Collapse")
	
		
		If strExpandedUID <> "" Then		
			If strType = "TestPlan" Then
				intArraySize = UBound(ExpandedTestPlans)
				ReDim Preserve ExpandedTestPlans(intArraySize + 1)
				ExpandedTestPlans(intArraySize + 1) = strExpandedUID			
			End If
			If strType = "TestCaseFolder" Then
				intArraySize = UBound(ExpandedTestCaseFolders)
				ReDim Preserve ExpandedTestCaseFolders(intArraySize + 1)
				ExpandedTestCaseFolders(intArraySize + 1) = strExpandedUID			
			End If
			If strType = "TestCase" Then
				intArraySize = UBound(ExpandedTestCases)
				ReDim Preserve ExpandedTestCases(intArraySize + 1)
				ExpandedTestCases(intArraySize + 1) = strExpandedUID			
			End If
		End If
		If strCollapseUID <> "" Then
			If strType = "TestPlan" Then
				intArraySize = UBound(ExpandedTestPlans)
				For i = 1 To intArraySize
					If strCollapseUID = ExpandedTestPlans(i) Then
						ExpandedTestPlans(i) = ExpandedTestPlans(intArraySize)
						ReDim Preserve ExpandedTestPlans(intArraySize-1)
						Exit For
					End If
				Next
			End If
			If strType = "TestCaseFolder" Then
				intArraySize = UBound(ExpandedTestCaseFolders)
				For i = 1 To intArraySize
					If strCollapseUID = ExpandedTestCaseFolders(i) Then
						ExpandedTestCaseFolders(i) = ExpandedTestCaseFolders(intArraySize)
						ReDim Preserve ExpandedTestCaseFolders(intArraySize-1)
						Exit For
					End If
				Next
			End If
			If strType = "TestCase" Then
				intArraySize = UBound(ExpandedTestCases)
				For i = 1 To intArraySize
					If strCollapseUID = ExpandedTestCases(i) Then
						ExpandedTestCases(i) = ExpandedTestCases(intArraySize)
						ReDim Preserve ExpandedTestCases(intArraySize-1)
						Exit For
					End If
				Next
			End If		
		End If
		
		Session("ExpandedTestPlans") = ExpandedTestPlans
		Session("ExpandedTestCaseFolders") = ExpandedTestCaseFolders
		Session("ExpandedTestCases") = ExpandedTestCases
			
		' Pick the right cancel state.
		If Request.QueryString("Cancel") = "Login" Then			
			Session("SubmitRepoInfo") = Empty
			Session("UserID") = Empty
			Session("Password") = Empty
			Session("Project") = Empty
			Session("Location") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp", "TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
			Exit Sub
		ElseIf Request.QueryString("Cancel") = "Display" Then
			Session("BackToDisplay") = Empty
			%>
			<script language='JavaScript'>
				window.open("default.asp", "TestManager<%=Session("SessionID")%>");
				window.close();
			</script>
			<%
			Exit Sub
		End If

		' Exit if a script is selected.
		strUID = Session("TestCaseUID")
		strParentUID = Request.QueryString("ParentUID")
		If strUID <> "" Then

			Set TMSServerPtr = Session("TMSServerPtr")
			If Err.Number <> 0 Then
				Exit Sub
			End if
			If Session("TestCaseType") = "Configured" Then
				If strParentUID <> "" Then
					Set TMSParentTestCasePtr = TMSServerPtr.GetTestCase(strParentUID)
					If Err.Number <> 0 Then
						Exit Sub
					End if
				End If
				Set TMSTestCasePtr = TMSServerPtr.GetConfiguredTestCase(strUID)
				If Err.Number <> 0 Then
					Exit Sub
				End if
			Else
				Set TMSTestCasePtr = TMSServerPtr.GetTestCase(strUID)		
				If Err.Number <> 0 Then
					Exit Sub
				End if
			End If

			Session("TestCaseName") = TMSTestCasePtr.Name
			If Err.Number <> 0 then
				Exit Sub
			End If

			If strParentUID <> "" Then
				Session("ScriptName") = TMSParentTestCasePtr.PropertyValue("ManualImplementation")
				If Err.Number <> 0 then
					Exit Sub
				End If			
			Else
				Session("ScriptName") = TMSTestCasePtr.PropertyValue("ManualImplementation")
				If Err.Number <> 0 then
					Exit Sub
				End If
			End If
		
			Session("DataLoaded") = Empty
			Session("SubmitScriptName") = true
			%>
			<script language='JavaScript'>
				window.open("default.asp","TestManager<%=Session("SessionID")%>");
			</script>
			<%
			Exit Sub
		End If
	End Sub

	Sub DisplayRoots()
		' requires:
		' modifies: 
		' effects:
	
		On Error Resume Next

		' object declaration
		Dim TMSServerPtr
		Dim TMSTestPlanPtr
		Dim TMSTestPlanColPtr
		Dim TMSTestCaseFolderColPtr

		' primitive declaration
		Dim i
		Dim j
		Dim intDepth
		Dim intBlankDepth
		Dim strName
		Dim strUID
		Dim strExpandedUID
		Dim bNeedsExpansion
		Dim bHasChildren

		Dim strIconExpander
		Dim strIconNode
		Dim strExpandText
		Dim ExpandedTestPlans
		
		ExpandedTestPlans = Session("ExpandedTestPlans")

		' initialization
		intDepth = 1
		intBlankDepth = 0
		bNeedsExpansion = False
		bHasChildren = False

		Set TMSServerPtr = Session("TMSServerPtr")
		If Err.Number <> 0 Then
			Exit Sub
		End if
		Set TMSTestPlanColPtr = TMSServerPtr.TestPlans
		If Err.Number <> 0 then
			Exit Sub
		End if
		
		For i = 1 To TMSTestPlanColPtr.Count
			If Err.number <> 0 then
				Err.number = 0
			End If		
		
			bNeedsExpansion = False
			bHasChildren = False
			strName = TMSTestPlanColPtr.Name(i)
			If Err.Number <> 0 then
				Exit Sub
			End If		
			strUID = TMSTestPlanColPtr.UID(i)
			If Err.Number <> 0 then
				Exit Sub
			End If

			' See if the plan has children

			Set TMSTestPlanPtr = TMSTestPlanColPtr.Item(i)
			If Err.Number <> 0 then
				Exit Sub
			End If
			Set TMSTestCaseFolderColPtr = TMSTestPlanPtr.GetTestCaseFolders()
			If Err.Number <> 0 then
				Exit Sub
			End If
			
			If TMSTestCaseFolderColPtr.Count > 0 then
				bHasChildren = True
			End If


			' See if the plan is expanded

			If UBound(ExpandedTestPlans) <> 0 Then
				For j = 1 to UBound(ExpandedTestPlans)
					strExpandedUID = ExpandedTestPlans(j)
					If strExpandedUID = strUID Then
						bNeedsExpansion = True
						Exit For
					End If
				Next 
			End If

			' Draw plan

			strIconNode = "'./images/Select_TestPlan.gif'"
			strExpandText = ""

			If bHasChildren = True AND bNeedsExpansion = True then
				If i = TMSTestPlanColPtr.Count And i = 1 then
					strIconExpander = "'./images/Select_Minus.gif'"				
				ElseIf i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_Minus_TTop.gif'"
				ElseIf i = 1 then
					strIconExpander = "'./images/Select_Minus_TBottom.gif'"
				Else
					strIconExpander = "'./Images/Select_Minus_T.gif'"
				End If
				strExpandText = "Collapse=" + strUID
			ElseIf bHasChildren = True AND bNeedsExpansion = False then
				If i = TMSTestPlanColPtr.Count And i = 1 then
					strIconExpander = "'./images/Select_Plus.gif'"				
				ElseIf i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_Plus_TTop.gif'"
				ElseIf i = 1 then
					strIconExpander = "'./images/Select_Plus_TBottom.gif'"
				Else
					strIconExpander = "'./Images/Select_Plus_T.gif'"
				End If
				strExpandText = "Expand=" + strUID
			ElseIf bHasChildren = False AND bNeedsExpansion = False then
				If i = 1 then
					strIconExpander = "'./images/Select_TBottom.gif'"
				ElseIf i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If
			Else
				If i = 1 then
					strIconExpander = "'./images/Select_TBottom.gif'"
				ElseIf i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If
			End If


%>
		<table border=0 cellspacing=0 cellpadding=0>
			<tr>
				<td><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestPlan' target='tm_content<%=Session("SessionID")%>'><img src=<%=strIconExpander%> width=16 height=22 border=0><img src=<%=strIconNode%> width=16 height=22 border=0></a></td>
				<td valign=middle nowrap><font face='Arial, sans-serif' size=1><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestPlan' target='tm_content<%=Session("SessionID")%>'><%=strName%></a></td>
			</tr>
		</table>
<%
			' Draw expanded children
			If bNeedsExpansion = True then
				If i = TMSTestPlanColPtr.Count then
					intBlankDepth = 1
				End If
				DisplayTestPlan TMSTestPlanPtr, intDepth, intBlankDepth
			End If
		Next				
	End Sub

	Sub DisplayTestPlan(TMSTestPlanPtr, intDepth, intBlankDepth)
		' requires:
		' modifies: 
		' effects:
		
		On Error Resume Next

		' object declaration
		Dim TMSTestCaseFolderPtr
		Dim TMSTestCaseFolderColPtr
		Dim TMSChildTestCaseFolderColPtr
		Dim TMSTestCaseColPtr

		' primitive declaration
		Dim i
		Dim j
		Dim k
		Dim strName
		Dim strUID
		Dim strExpandedUID
		Dim bNeedsExpansion
		Dim bHasChildren

		Dim strIconExpander
		Dim strIconNode
		Dim strExpandText

		Dim ExpandedTestCaseFolders 
		ExpandedTestCaseFolders = Session("ExpandedTestCaseFolders")

		Dim intBlankTemp
		intBlankTemp = intBlankDepth

		' initialization
		bNeedsExpansion = False
		bHasChildren = False

		Set TMSTestCaseFolderColPtr = TMSTestPlanPtr.GetTestCaseFoldersSorted()
		If Err.Number <> 0 then
			Exit Sub
		End If		
		

		For i = 1 to TMSTestCaseFolderColPtr.Count	
			bNeedsExpansion = False
			bHasChildren = False
			intBlankDepth = intBlankTemp
			Err.Number = 0
			strName = TMSTestCaseFolderColPtr.Name(i)
			If Err.Number <> 0 then
				Exit Sub
			End If
			
			strUID = TMSTestCaseFolderColPtr.UID(i)
			If Err.Number <> 0 then
				Exit Sub
			End If
			Set TMSTestCaseFolderPtr = TMSTestCaseFolderColPtr.Item(i)
			If Err.Number <> 0 then
				Exit Sub
			End If
			' See if the folder has children
			Set TMSChildTestCaseFolderColPtr = TMSTestCaseFolderPtr.GetChildFolders()
			If Err.Number <> 0 then
				Exit Sub
			End If
			
			If TMSChildTestCaseFolderColPtr.Count > 0 then
				bHasChildren = True
			Else
				' Misleading, but needed for performance reasons.
				Set TMSTestCaseColPtr = TMSTestCaseFolderPtr.GetTestCasesSorted()
				If Err.Number <> 0 then
					Exit Sub
				End If
				If TMSTestCaseColPtr.Count > 0 then
					bHasChildren = True
				End If	
			End If

			' See if the folder is expanded

			If UBound(ExpandedTestCaseFolders) <> 0 Then
				For j = 1 to UBound(ExpandedTestCaseFolders)
					strExpandedUID = ExpandedTestCaseFolders(j)
					If strExpandedUID = strUID Then
						bNeedsExpansion = True
						Exit For
					End If
				Next 
			End If
			
			' Draw test case folder

			strIconNode = "'./images/Select_TestCaseFolder_Closed.gif'"
			strExpandText = ""

			If bHasChildren = True AND bNeedsExpansion = True then
				If i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_Minus_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_Minus_T.gif'"
				End If
				strIconNode = "'./images/Select_TestCaseFolder_Opened.gif'"
				strExpandText = "Collapse=" + strUID
			ElseIf bHasChildren = True AND bNeedsExpansion = False then
				If i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_Plus_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_Plus_T.gif'"
				End If
				strExpandText = "Expand=" + strUID
			ElseIf bHasChildren = False AND bNeedsExpansion = False then
				If i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If
			Else
				If i = TMSTestPlanColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If
			End If
							
%>
		<table border=0 cellspacing=0 cellpadding=0>
			<tr>
				<td><% For k = 1 to intBlankDepth %><img src='./images/Select_Blank.gif' width=16 height=22 border=0><% Next %><% For k = 1 to (intDepth - intBlankDepth) %><img src='./images/Select_VLine.gif' width=16 height=22 border=0><% Next %><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestCaseFolder' target='tm_content<%=Session("SessionID")%>'><img src=<%=strIconExpander%> width=16 height=22 border=0><img src=<%=strIconNode%> width=16 height=22 border=0></a></td>
				<td valign=middle nowrap><font face='Arial, sans-serif' size=1><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestCaseFolder' target='tm_content<%=Session("SessionID")%>'><%=strName%></a></td>
			</tr>
		</table>
<%

			' Draw expanded children
			If bNeedsExpansion = True then
				If i = TMSTestCaseFolderColPtr.Count then
					intBlankDepth = intBlankDepth + 1
				End If
				DisplayTestCaseFolder TMSTestCaseFolderPtr, intdepth + 1, intBlankDepth
			End If							
		Next
	End Sub

	Sub DisplayTestCaseFolder(TMSTestCaseFolderPtr, intDepth, intBlankDepth)
		' requires:
		' modifies: 
		' effects:

		On Error Resume Next

		' object declaration
		Dim TMSCofiguredTestCaseColPtr
		Dim TMSChildTestCaseColPtr
		Dim TMSTestCaseFolderColPtr
		Dim TMSChildTestCaseFolderPtr
		Dim TMSChildTestCaseFolderColPtr
		Dim TMSTestCaseColPtr

		' primitive declaration
		Dim i
		Dim j
		Dim k
		Dim strName
		Dim strUID
		Dim strExpandedUID
		Dim bNeedsExpansion
		Dim bHasChildren
		Dim strManualScriptName

		Dim strIconExpander
		Dim strIconNode
		Dim strExpandText

		Dim ExpandedTestCaseFolders
		Dim ExpandedTestCases
		
		Dim intBlankTemp
		intBlankTemp = intBlankDepth
		
		ExpandedTestCaseFolders = Session("ExpandedTestCaseFolders")
		ExpandedTestCases = Session("ExpandedTestCases")

		' initialization
		bNeedsExpansion = False
		bHasChildren = False

		Set TMSTestCaseFolderColPtr = TMSTestCaseFolderPtr.GetChildFolders()
		If Err.Number <> 0 then
			Exit Sub
		End If

		Set TMSTestCaseColPtr = TMSTestCaseFolderPtr.GetTestCasesSorted()
		If Err.Number <> 0 then
			Exit Sub
		End If
						
		For i = 1 To TMSTestCaseFolderColPtr.Count
			bNeedsExpansion = False
			bHasChildren = False
			intBlankDepth = intBlankTemp
			Err.Number = 0		
			strName = TMSTestCaseFolderColPtr.Name(i)
			If Err.Number <> 0 then
				Exit Sub
			End If		
			strUID = TMSTestCaseFolderColPtr.UID(i)
			If Err.Number <> 0 then
				Exit Sub
			End If

			' See if the folder has children

			Set TMSChildTestCaseFolderPtr = TMSTestCaseFolderColPtr.Item(i)
			If Err.Number <> 0 then
				Exit Sub
			End If

			Set TMSChildTestCaseFolderColPtr = TMSChildTestCaseFolderPtr.GetChildFolders()
			If Err.Number <> 0 then
				Exit Sub
			End If
			
			If TMSChildTestCaseFolderColPtr.Count > 0 then
				bHasChildren = True
			Else
				' Misleading, but needed for performance reasons.
				Set TMSChildTestCaseColPtr = TMSChildTestCaseFolderPtr.GetTestCasesSorted()
				If Err.Number <> 0 then
					Exit Sub
				End If
				If TMSChildTestCaseColPtr.Count > 0 then
					bHasChildren = True
				End If	
			End If

			' See if the folder is expanded

			If UBound(ExpandedTestCaseFolders) <> 0 Then
				For j = 1 to UBound(ExpandedTestCaseFolders)
					strExpandedUID = ExpandedTestCaseFolders(j)
					If strExpandedUID = strUID Then
						bNeedsExpansion = True
						Exit For
					End If
				Next 
			End If

			' Draw test case folder

			strIconNode = "'./images/Select_TestCaseFolder_Closed.gif'"
			strExpandText = ""

			If bHasChildren = True AND bNeedsExpansion = True then
				If i = TMSTestCaseFolderColPtr.Count then
					strIconExpander = "'./images/Select_Minus_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_Minus_T.gif'"
				End If
				strIconNode = "'./images/Select_TestCaseFolder_Opened.gif'"
				strExpandText = "Collapse=" + strUID
			ElseIf bHasChildren = True AND bNeedsExpansion = False then
				If i = TMSTestCaseFolderColPtr.Count then
					strIconExpander = "'./images/Select_Plus_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_Plus_T.gif'"
				End If
				strExpandText = "Expand=" + strUID
			ElseIf bHasChildren = False AND bNeedsExpansion = False then
				If i = TMSTestCaseFolderColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If
			Else
				If i = TMSTestCaseFolderColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If
			End If

%>
		<table border=0 cellspacing=0 cellpadding=0>
			<tr>
				<td><% For k = 1 to (intDepth - intBlankDepth) %><img src='./images/Select_VLine.gif' width=16 height=22 border=0><% Next
				       For k = 1 to intBlankDepth %><img src='./images/Select_Blank.gif' width=16 height=22 border=0><% Next %><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestCaseFolder' target='tm_content<%=Session("SessionID")%>'><img src=<%=strIconExpander%> width=16 height=22 border=0><img src=<%=strIconNode%> width=16 height=22 border=0></a></td>
				<td valign=middle nowrap><font face='Arial, sans-serif' size=1><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestCaseFolder' target='tm_content<%=Session("SessionID")%>'><%=strName%></a></td>
			</tr>
		</table>
<%

			' Draw expanded children

			If bNeedsExpansion = True then
				If i = TMSTestCaseFolderColPtr.Count then
					intBlankDepth = intBlankDepth + 1
				End If
				DisplayTestCaseFolder TMSChildTestCaseFolderPtr, intdepth + 1, intBlankDepth
			End If
		Next
	
		For i = 1 To TMSTestCaseColPtr.Count
			strManualScriptName = ""
			bNeedsExpansion = False
			bHasChildren = False
			intBlankDepth = intBlankTemp
			Err.Number = 0		
			strName = TMSTestCaseColPtr.Name(i)
			If Err.Number <> 0 then
				Exit Sub
			End If		
			strUID = TMSTestCaseColPtr.UID(i)
			If Err.Number <> 0 then
				Exit Sub
			End If

			' See if the test case has children

			Set TMSChildTestCasePtr = TMSTestCaseColPtr.Item(i)
			If Err.Number <> 0 then
				Exit Sub
			End If
			Set TMSConfiguredTestCaseColPtr = TMSChildTestCasePtr.GetConfiguredTestCases()
			If Err.Number <> 0 then
				Exit Sub
			End If
			
			' Misleading, but needed for performance reasons.
			If TMSConfiguredTestCaseColPtr.Count > 0 then
				bHasChildren = True
			End If

			' See if the test case is expanded

			If UBound(ExpandedTestCases) <> 0 Then
				For j = 1 to UBound(ExpandedTestCases)
					strExpandedUID = ExpandedTestCases(j)
					If strExpandedUID = strUID Then
						bNeedsExpansion = True
						Exit For
					End If
				Next 
			End If

			' If test case has a manual script, draw test case

			strManualScriptName = TMSChildTestCasePtr.PropertyValue("ManualImplementation")
			If Err.Number <> 0 then
				Exit Sub
			End If
								
			If strManualScriptName <> "" then

				' Draw test case

				strIconNode = "'./images/Select_TestCase.gif'"
				strExpandText = ""
		
				If bHasChildren = True AND bNeedsExpansion = True then
					If i = TMSTestCaseColPtr.Count then
						strIconExpander = "'./images/Select_Minus_TTop.gif'"
					Else
						strIconExpander = "'./Images/Select_Minus_T.gif'"
					End If
					strExpandText = "Collapse=" + strUID
				ElseIf bHasChildren = True AND bNeedsExpansion = False then
					If i = TMSTestCaseColPtr.Count then
						strIconExpander = "'./images/Select_Plus_TTop.gif'"
					Else
						strIconExpander = "'./Images/Select_Plus_T.gif'"
					End If
					strExpandText = "Expand=" + strUID
				ElseIf bHasChildren = False AND bNeedsExpansion = False then
					If i = TMSTestCaseColPtr.Count then
						strIconExpander = "'./images/Select_TTop.gif'"
					Else
						strIconExpander = "'./Images/Select_T.gif'"
					End If
				Else
					If i = TMSTestCaseColPtr.Count then
						strIconExpander = "'./images/Select_TTop.gif'"
					Else
						strIconExpander = "'./Images/Select_T.gif'"
					End If
				End If
%>
		<table border=0 cellspacing=0 cellpadding=0>
			<tr>
				<td><% For k = 1 to (intDepth - intBlankDepth) %><img src='./images/Select_VLine.gif' width=16 height=22 border=0><% Next
				       For k = 1 to intBlankDepth %><img src='./images/Select_Blank.gif' width=16 height=22 border=0><% Next %><a href='prompt_testcase_name.asp?State=PromptScriptName&<%=strExpandText%>&Type=TestCase' target='tm_content<%=Session("SessionID")%>'><img src=<%=strIconExpander%> width=16 height=22 border=0><img src=<%=strIconNode%> width=16 height=22 border=0></a></td>
				<td valign=middle nowrap><font face='Arial, sans-serif' size=1><a href='prompt_testcase_name.asp?State=PromptScriptName&TestCaseType=Abstract&TestCaseUID=<%=strUID%>' target='tm_content<%=Session("SessionID")%>'><%=strName%></a></td>
			</tr>
		</table>
<%
			End If

			' Draw expanded children

			If bNeedsExpansion = True then
				If i = TMSTestCaseColPtr.Count then
					intBlankDepth = intBlankDepth + 1
				End If
				DisplayTestCase TMSChildTestCasePtr, intdepth + 1, intBlankDepth
			End If
		Next

	End Sub

	Sub DisplayTestCase(TMSTestCasePtr, intDepth, intBlankDepth)
		' requires:
		' modifies: 
		' effects:

		On Error Resume Next

		' object declaration
		Dim TMSServerPtr
		Dim TMSConfiguredTestCasePtr
		Dim TMSConfiguredTestCaseColPtr

		' primitive declaration
		Dim i
		Dim j
		Dim k
		Dim strName
		Dim strUID
		Dim strParentUID
		Dim strManualScriptName
		Dim strParentScriptName
		Dim strDatastorePath

		Dim bNeedsExpansion
		Dim bHasChildren

		Dim intBlankTemp
		intBlankTemp = intBlankDepth

		' initialization
		bNeedsExpansion = False
		bHasChildren = False

		Set TMSConfiguredTestCaseColPtr = TMSTestCasePtr.GetConfiguredTestCases()
		If Err.Number <> 0 then
			Exit Sub
		End If
		
		For i = 1 To TMSConfiguredTestCaseColPtr.Count
			intBlankDepth = intBlankTemp
			strParentUID = ""
			strManualScriptName = ""
			Err.Number = 0		
			strName = TMSConfiguredTestCaseColPtr.Name(i)
			If Err.Number <> 0 then
				Exit Sub
			End If		
			strUID = TMSConfiguredTestCaseColPtr.UID(i)
			If Err.Number <> 0 then
				Exit Sub
			End If

			' If configured test case has manual implemenation, draw test case
			Set TMSConfiguredTestCasePtr = TMSConfiguredTestcaseColPtr.Item(i)
			If Err.Number <> 0 then
				Exit Sub
			End If

			strManualScriptName = TMSConfiguredTestCasePtr.PropertyValue("ManualImplementation")
			If Err.Number <> 0 then
			End If

			' Inherited implementations yuck.

			If strManualScriptName = "" then
				strManualScriptName = TMSTestCasePtr.PropertyValue("ManualImplementation")
				If Err.Number = 0 then
					strParentUID = TMSTestCasePtr.UID				
					If Err.Number <> 0 then
						Exit Sub
					End If				
				End If
			End If
			
			If strManualScriptName <> "" then

				' Draw configured test case

				strIconNode = "'./images/Select_ConfiguredTestCase.gif'"

				If i = TMSConfiguredTestCaseColPtr.Count then
					strIconExpander = "'./images/Select_TTop.gif'"
				Else
					strIconExpander = "'./Images/Select_T.gif'"
				End If

%>
		<table border=0 cellspacing=0 cellpadding=0>
			<tr>
				<td><% For k = 1 to (intDepth - intBlankDepth) %><img src='./images/Select_VLine.gif' width=16 height=22 border=0><% Next
				       For k = 1 to intBlankDepth %><img src='./images/Select_Blank.gif' width=16 height=22 border=0><% Next %><img src=<%=strIconExpander%> width=16 height=22 border=0><img src=<%=strIconNode%> width=16 height=22 border=0></td>
				<td valign=middle nowrap><font face='Arial, sans-serif' size=1><a href='prompt_testcase_name.asp?State=PromptScriptName&TestCaseType=Configured&TestCaseUID=<%=strUID%>&ParentUID=<%=strParentUID%>' target='tm_content<%=Session("SessionID")%>'><%=strName%></a></td>
			</tr>
		</table>
<%

			End If
		Next
	End Sub


	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the script name dialog filling in appropriate 
		'			fields based on previous input.
		%>
		<html>
		<head>
			<title>
				Select Script
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 9pt} 
			</style>
			<script language='JavaScript'>
				function getHelp() 
				{
					window.open('./help/help.asp?anchor=selectscript','TestManagerHelp');
				}
			</script>
		</head>
		<body bgcolor='#ffffff'>
		<%
		DisplayRoots()
		%>
		</body>
		</html>
		<%
	End Sub
%>