<%
' Copyright 1998-2001 Rational Software Corporation
'
'   File: constants.inc

' /* IBM Confidential 
' *(c) Copyright IBM Corp. 2000 - 2006  All Rights Reserved.
' *The source code for this program is not published or otherwise 
' *divested of its trade secrets, irrespective of what has been 
' *deposited with the U.S. Copyright Office.
' */

'
'	Modification History:
'	
'	Date		Who			What
'	6/23/99		PSun		Added modification history.
'							Added manual test constants support. 
'	8/25/99		PSun		Code cleanup.
'	7/18/00		PSun		Added ML constants.
'	12/12/00	PSun		Added ML logging constants
'       7/11/02         OMoroz		Added new constant SZ_TMS_PROPERTY_NAME_MANUALSTEP_NAME
'

' Keep constant values here...

' Record Types
Const RAS_LOGFILE_RECORD_TYPE_HEADER =	1
Const RAS_LOGFILE_RECORD_TYPE_EVENT =	2

' Log File Open Modes
Const RAS_LOGFILE_MODE_NONE =			0
Const RAS_LOGFILE_MODE_READ =			1
Const RAS_LOGFILE_MODE_WRITE =			2
Const RAS_LOGFILE_MODE_APPEND =			3

' Log File Filter Options
Const RAS_LOGFILE_FILTER_NONE =							1
Const RAS_LOGFILE_FILTER_MASTER_ONLY =					2
Const RAS_LOGFILE_FILTER_FAILED_ONLY =					3
Const RAS_LOGFILE_FILTER_PASS_SUMMARY_FAILED_DETAILS =	4

' Event Types related to control flow
Const RAS_LOGEVENT_TYPE_UNKNOWN =				0
Const RAS_LOGEVENT_TYPE_START_LOGFILE =			1
Const RAS_LOGEVENT_TYPE_SCRIPT_START =			2
Const RAS_LOGEVENT_TYPE_SCRIPT_END =			3
Const RAS_LOGEVENT_TYPE_SCHEDULE_START =		4
Const RAS_LOGEVENT_TYPE_SCHEDULE_END =			5
Const RAS_LOGEVENT_TYPE_EXECUTABLE_START =		6
Const RAS_LOGEVENT_TYPE_EXECUTABLE_TERMINATE =	7
Const RAS_LOGEVENT_TYPE_EXECUTABLE_END =		8
Const RAS_LOGEVENT_TYPE_CALL_SCRIPT	=			9
Const RAS_LOGEVENT_TYPE_CALL_EXECUTABLE =		10
Const RAS_LOGEVENT_TYPE_USER_START =			11
Const RAS_LOGEVENT_TYPE_USER_END =				12

Const RAS_LOGEVENT_TYPE_TIMER_START	=			16
Const RAS_LOGEVENT_TYPE_TIMER_STOP =			17
Const RAS_LOGEVENT_TYPE_TIMER_ABORT =			18
Const RAS_LOGEVENT_TYPE_APPLICATION_START =		19

' Event Types specific to Script execution
Const RAS_LOGEVENT_TYPE_VERIFICATION_POINT =	21
Const RAS_LOGEVENT_TYPE_LOGMESSAGE =			22
Const RAS_LOGEVENT_TYPE_USERDEFINED	=			23
Const RAS_LOGEVENT_TYPE_PLAYBACK_WARNING =		24
Const RAS_LOGEVENT_TYPE_CONFIGURATION =			27
Const RAS_LOGEVENT_TYPE_MANUAL_STEP =			28

'  Event Types Specific to Purify/Quantify
Const RAS_LOGEVENT_TYPE_PURIFY =				31
Const RAS_LOGEVENT_TYPE_QUANTIFY =				32
Const RAS_LOGEVENT_TYPE_COVERAGE =				33
Const RAS_LOGEVENT_TYPE_PURIFY_SUMMARY =		34
Const RAS_LOGEVENT_TYPE_QUANTIFY_SUMMARY =		35
Const RAS_LOGEVENT_TYPE_COVERAGE_SUMMARY =		36

' Error type events
Const RAS_LOGEVENT_TYPE_COMMAND_FAILURE =		41
Const RAS_LOGEVENT_TYPE_UAW =					42
Const RAS_LOGEVENT_TYPE_ABORT =					43
Const RAS_LOGEVENT_TYPE_GPF =					44
Const RAS_LOGEVENT_TYPE_INTERNAL_SYSTEM_ERROR =	45
Const RAS_LOGEVENT_TYPE_AGENT_ERROR =			46
Const RAS_LOGEVENT_TYPE_GENERAL_ERROR =			47

' Result Codes
Const RAS_LOGEVENT_RESULT_NONE =			0
Const RAS_LOGEVENT_RESULT_PASS =			1
Const RAS_LOGEVENT_RESULT_FAIL =			2
Const RAS_LOGEVENT_RESULT_WARNING =			3
Const RAS_LOGEVENT_RESULT_STOPPED =			4
Const RAS_LOGEVENT_RESULT_INFORMATIONAL =	5

' Result of a Mnaual Step
Const RAS_LOGEVENT_RESULT_COMPLETED =		6

' Failure Reasons
Const RAS_LOGEVENT_FAILURE_REASON_NONE =					0
Const RAS_LOGEVENT_FAILURE_REASON_DID_NOT_COMPLETE =		1
Const RAS_LOGEVENT_FAILURE_REASON_ABORT =					2
Const RAS_LOGEVENT_FAILURE_REASON_SKIP_CURRENT_SCRIPT =		3
Const RAS_LOGEVENT_FAILURE_REASON_REBOOT_SYSTEM	=			4
Const RAS_LOGEVENT_FAILURE_REASON_UNKNOWN	=				5
Const RAS_LOGEVENT_FAILURE_REASON_EXE_DID_NOT_START =		6
Const RAS_LOGEVENT_FAILURE_REASON_EXE_TERMINATED =			7
Const RAS_LOGEVENT_FAILURE_REASON_EXE_ERROR =				8
Const RAS_LOGEVENT_FAILURE_REASON_AGENT_CONNECTION_ERROR =	9
			
' User Types
Const RAS_LOGEVENT_USER_TYPE_NONE =	0
Const RAS_LOGEVENT_USER_TYPE_GUI =	1
Const RAS_LOGEVENT_USER_TYPE_VU =	2

' Verification Point Types
Const RAS_VPTYPE_NONE =					0
Const RAS_VPTYPE_WINDOW_IMAGE =			1
Const RAS_VPTYPE_REGION_IMAGE =			2 
Const RAS_VPTYPE_ALPHANUMERIC =			3
Const RAS_VPTYPE_MENU =					4
Const RAS_VPTYPE_CLIPBOARD =		    5
Const RAS_VPTYPE_FILE_EXISTANCE =		6
Const RAS_VPTYPE_FILE_COMPARISON =	    7
Const RAS_VPTYPE_WINDOW_EXISTANCE =		8
Const RAS_VPTYPE_MODULE_EXISTANCE =		9
Const RAS_VPTYPE_OBJECT_PROPERTIES =	10 
Const RAS_VPTYPE_OBJECT_DATA =			11
Const RAS_VPTYPE_WEBSITE_SCAN =			12
Const RAS_VPTYPE_WEBSITE_COMPARE =		13
Const RAS_VPTYPE_CUSTOM =				14
Const RAS_VPTYPE_MANUAL =				15
Const RAS_FIRST_VPTYPE =				1
Const RAS_LAST_VPTYPE =					15


Const TMS_LOG_EVENT_RESULT_NONE =			0	
Const TMS_LOG_EVENT_RESULT_PASS =			1
Const TMS_LOG_EVENT_RESULT_FAIL =			2
Const TMS_LOG_EVENT_RESULT_WARNING =		3
Const TMS_LOG_EVENT_RESULT_STOPPED =		4
Const TMS_LOG_EVENT_RESULT_INFORMATIONAL =	5
Const TMS_LOG_EVENT_RESULT_COMPLETED =		6
Const TMS_LOG_EVENT_UNEVALUATED =			7

Const TMS_LOG_EVENT_TYPE_UNKNOWN =					0
Const TMS_LOG_EVENT_TYPE_CONFIGURATION =			1
Const TMS_LOG_EVENT_TYPE_START_LOG_FILE =			2
Const TMS_LOG_EVENT_TYPE_SCRIPT_START =				3
Const TMS_LOG_EVENT_TYPE_SCRIPT_END =				4
Const TMS_LOG_EVENT_TYPE_SUITE_START =				5
Const TMS_LOG_EVENT_TYPE_SUITE_END =				6
Const TMS_LOG_EVENT_TYPE_EXECUTABLE_START =			7
Const TMS_LOG_EVENT_TYPE_EXECUTABLE_TERMINATE =		8
Const TMS_LOG_EVENT_TYPE_EXECUTABLE_END =			9
Const TMS_LOG_EVENT_TYPE_CALL_SCRIPT =				10
Const TMS_LOG_EVENT_TYPE_CALL_EXECUTABLE =			11
Const TMS_LOG_EVENT_TYPE_USER_START =				12
Const TMS_LOG_EVENT_TYPE_USER_END =					13
Const TMS_LOG_EVENT_TYPE_COMPUTER_START =			14
Const TMS_LOG_EVENT_TYPE_COMPUTER_END =				15
Const TMS_LOG_EVENT_TYPE_TIMER_START =				16
Const TMS_LOG_EVENT_TYPE_TIMER_END =				17
Const TMS_LOG_EVENT_TYPE_TIMER_ABORT =				18
Const TMS_LOG_EVENT_TYPE_APPLICATION_START =		19
Const TMS_LOG_EVENT_TYPE_VERIFICATION_POINT =		20
Const TMS_LOG_EVENT_TYPE_LOGMESSAGE =				21
Const TMS_LOG_EVENT_TYPE_USERDEFINED =				22
Const TMS_LOG_EVENT_TYPE_PLAYBACK_WARNING =			23
Const TMS_LOG_EVENT_TYPE_PURIFY =					24
Const TMS_LOG_EVENT_TYPE_QUANTIFY =					25
Const TMS_LOG_EVENT_TYPE_COVERAGE =					26
Const TMS_LOG_EVENT_TYPE_PURIFY_SUMMARY =			27
Const TMS_LOG_EVENT_TYPE_QUANTIFY_SUMMARY =			28
Const TMS_LOG_EVENT_TYPE_COVERAGE_SUMMARY =			29
Const TMS_LOG_EVENT_TYPE_COMMAND_FAILURE =			30
Const TMS_LOG_EVENT_TYPE_UAW =						31
Const TMS_LOG_EVENT_TYPE_ABORT =					32
Const TMS_LOG_EVENT_TYPE_GPF =						33
Const TMS_LOG_EVENT_TYPE_INTERNAL_SYSTEM_ERROR =	34
Const TMS_LOG_EVENT_TYPE_AGENT_ERROR =				35
Const TMS_LOG_EVENT_TYPE_GENERAL_ERROR =			36
Const TMS_LOG_EVENT_TYPE_MANUALSTEP =				37
Const TMS_LOG_EVENT_TYPE_INSERT_AGENT_LOG_FILE =	38
Const TMS_LOG_EVENT_TYPE_TESTCASE =					39
Const TMS_LOG_EVENT_TYPE_COMMAND =					40
Const TMS_LOG_EVENT_TYPE_MESSAGE =					41
Const TMS_LOG_EVENT_TYPE_START_TIME =				42
Const TMS_LOG_EVENT_TYPE_STOP_TIME =				43
Const TMS_LOG_EVENT_TYPE_ENV_VARIABLE_CHANGE =		44
Const TMS_LOG_EVENT_TYPE_SYNC_POINT =				45
Const TMS_LOG_EVENT_TYPE_ACTIVATE =					46
Const TMS_LOG_EVENT_TYPE_DEACTIVATE =				47
Const TMS_LOG_EVENT_TYPE_USER_DEFINED =				48
Const TMS_LOG_EVENT_TYPE_EMULATION_COMMAND =		49
Const TMS_LOG_EVENT_TYPE_TESTCASE_START =		50
Const TMS_LOG_EVENT_TYPE_TESTCASE_END =			51

Const TMS_LOG_EVENT_CATEGORY_UNKNOWN =		0
Const TMS_LOG_EVENT_CATEGORY_SYSTEM =		1
Const TMS_LOG_EVENT_CATEGORY_VU =			2
Const TMS_LOG_EVENT_CATEGORY_STRUCTURAL =	3
Const TMS_LOG_EVENT_CATEGORY_SUITE =		4
Const TMS_LOG_EVENT_CATEGORY_TEE =			5
Const TMS_LOG_EVENT_CATEGORY_TSS =			6
Const TMS_LOG_EVENT_CATEGORY_ROBOT =		7

Const SZ_TMS_PROPERTY_NAME_TESTCASE_UID = "_TMS8"
Const SZ_TMS_PROPERTY_NAME_TESTCASE_NAME = "_TMS9"
Const SZ_TMS_PROPERTY_NAME_ADDITIONAL_INFO = "_TMS14"
Const SZ_TMS_PROPERTY_NAME_SCRIPT_ID = "_TMS15"
Const SZ_TMS_PROPERTY_NAME_SCRIPT_SOURCE_UID = "_TMS16"
Const SZ_TMS_PROPERTY_NAME_SCRIPT_NAME = "_TMS17"
Const SZ_TMS_PROPERTY_NAME_SCRIPT_LINE_NUMBER = "_TMS18"
Const SZ_TMS_PROPERTY_NAME_VERIFICATION_POINT_NAME = "_TMS36"
Const SZ_TMS_PROPERTY_NAME_VERIFICATION_POINT_TYPE = "_TMS37"
Const SZ_TMS_PROPERTY_NAME_MANUALSTEP_NAME = "_TMS39"
Const SZ_TMS_PROPERTY_NAME_EXPECTED_RESULT = "_TMS91" 
Const SZ_TMS_PROPERTY_NAME_EXPECTED_RESULT_FILE = "_TMS92"  
Const SZ_TMS_PROPERTY_NAME_RESULT_DETAILS = "_TMS93"  
Const SZ_TMS_PROPERTY_NAME_RESULT_DETAILS_FILE = "_TMS94"  

'Login error messages
Const TMS_INVALID_SERVER = "No Database Server" 
Const TMS_INVALID_USERNAME_OR_PASSWORD = "Invalid User Name or Password"       '''''162
Const IDS_UNABLE_TO_CONNECT = "Unable to connect to project."
Const IDS_INVALID_USERNAME_OR_PASSWORD = "The specified username or password is incorrect."





Const TSS_LOG_RESULT_NONE = 0
Const TSS_LOG_RESULT_PASS = 1
Const TSS_LOG_RESULT_FAIL = 2
Const TSS_LOG_RESULT_WARN = 3
Const TSS_LOG_RESULT_STOPPED = 4
Const TSS_LOG_RESULT_INFO = 5
Const TSS_LOG_RESULT_COMPLETED = 6
Const TSS_LOG_RESULT_UNEVALUATED = 7

Const TMS_LOG_EVENT_FAILURE_REASON_NONE =			0
Const TMS_LOG_EVENT_FAILURE_REASON_DID_NOT_COMPLETE = 		1
Const TMS_LOG_EVENT_FAILURE_REASON_ABORT =			2
Const TMS_LOG_EVENT_FAILURE_REASON_SKIP_CURRENT_SCRIPT =	3
Const TMS_LOG_EVENT_FAILURE_REASON_REBOOT_SYSTEM =		4
Const TMS_LOG_EVENT_FAILURE_REASON_UNKNOWN =			5
Const TMS_LOG_EVENT_FAILURE_REASON_EXE_DID_NOT_START =		6
Const TMS_LOG_EVENT_FAILURE_REASON_EXE_TERMINATED = 		7
Const TMS_LOG_EVENT_FAILURE_REASON_EXE_ERROR =			8
Const TMS_LOG_EVENT_FAILURE_REASON_AGENT_CONNECTION_ERROR =	9
Const TMS_LOG_EVENT_FAILURE_REASON_SEE_DESCRIPTION =		10
Const TMS_LOG_EVENT_FAILURE_REASON_NO_MATCHING_CONFIGURATION =	11
Const TMS_LOG_EVENT_FAILURE_REASON_NO_IMPLEMENTATION = 		12
Const TMS_LOG_EVENT_FAILURE_REASON_PRECONDITION_NOT_MET =	13

Const TMS_VP_TYPE_MANUAL =					15
%>
