<%
' Copyright 1998, 1999, 2000 Rational Software Corporation
'
'	File: testmanager.inc
'
'	Modification History:
'	
'	Date		Who			What
'	6/25/99		PSun		File Created.  
'	7/7/99		PSun		Moved in GenerateBuildSelectByQuery and 
'							GenerateLogFolderSelectByFolderCol
'	7/15/99		PSun		Moved in SetResultAllPass and SetResultAllEmpty
'	7/23/99		PSun		Added GenerateRepositoryPathSelect and 
'							GenerateProjectSelect
'	8/12/99		PSun		Added filtering for externally attached manual
'							scripts in GenerateScriptNameSelectByQuery.
'							Added DateExpires
'	8/18/99		PSun		Changed GenerateRepositoryPathSelect's selected
'							value when target is not found.
'	8/19/99		PSun		Changed the way GenerateRepositoryPathSelect was
'							selecting a default repository.
'	8/25/99		PSun		Code cleanup.
'	11/29/99	PSun		Added default selection values for GenerateBuild-
'							SelectByQuery and GenerateLogFolderSelectby-
'							FolderCol
'							Changed SetResultsAllEmpty to clear comments.
'   7/10/00		PSun		Removed GenerateRepositoryPathSelect and modified
'							   GeneratePathSelect to use new data store
'	7/12/00		PSun		Changed GenerateBuildSelectByQuery, and
'							   GenerateLogFolderSelectByLogFolderCol to 
'							   GenerateBuildSelectByAssetCol and 
'							   GenerateLogFolderSelectByAssetCol respectively.
'							Modified Everything to use new data store.
'
	Function DateExpires(intYearAdj, intMonthAdj, intDayAdj)
		' requires:
		' modifies:
		' effects:	Generates a date that is adjusted by intYearAdj years,
		'			intMonthAdj months, and intDayAdj days.
		On Error Resume Next
	
		Dim intYear
		Dim intMonth
		Dim intDay
		intYear = Year(Now)+intYearAdj
		intMonth = Month(Now)+intMonthAdj
		intDay = Day(Now)+intDayAdj
		DateExpires = DateSerial(intYear, intMonth, intDate)
	End Function

	Function CreateWhiteSpace(intNumber)
		' requires: 
		' modifies: 
		' effects:  This function generates a string of intNumber HTML spaces.

		On Error Resume Next
		
		Dim intCounter
		Dim strResult

		strResult = ""	
		For intCounter = 1 to intNumber
			strResult = strResult + "&nbsp;"
		Next
	
		CreateWhiteSpace = strResult
	End Function
	
	Sub GenerateProjectSelect(strSelected, intSize, intWidth)
		' requires: intSize > 0, intWidth > 0
		' modifies: 
		' effects:  This function generates a select list of projects in the
		'			data store.  The selected attribute will be set for any 
		'           project with a name matching strSelected.  The select list 
		'           will display intSize number of items and be intWidth wide.

		On Error Resume Next

		Dim RAServerPtr
		Dim RAProjectsPtr
		Dim RAProjectPtr
		Dim intCounter
		Dim strName

		' Generate the select input object.
		Response.Write vbCrLf
		Response.Write vbTab+vbTab+vbTab+_
					   "<select size='"+CStr(intSize)+"' name='Project'"+_
					   " style='font-family: Courier; font-size: 9pt'>"+vbCrLf

		Set RAServerPtr = Server.CreateObject("RationalAdminServer.RAServer.1")
		If Err.Number <> 0 then
			Exit Sub
		End if
		
		Set RAProjectsPtr = RAServerPtr.GetProjects
		If Err.Number <> 0 then
			Exit Sub
		End if

		For intCounter = 1 to RAProjectsPtr.Count
			Set RAProjectPtr = RAProjectsPtr.Item(intCounter)
			strName = RAProjectPtr.Name
			If strName = strSelected Then
				Response.Write  vbTab+vbTab+vbTab+vbTab+_
								"<option selected>"+_
								strName+"</option>"+vbCrLf
			Else
				Response.Write	vbTab+vbTab+vbTab+vbTab+_
								"<option>"+strName+_
								"</option>"+vbCrLf
			End If
		Next		
	
		' Hack the width of the netscape select box (YUCK!).
		'If BrowserIsNetscape Then
		'	intWidth = intWidth+ 55
		'End If

		' Create a dummy select option that sets the size (Again, YUCK!).
		Response.Write vbTab+vbTab+vbTab+vbTab+_
					   "<option value=''>"+CreateWhiteSpace(intWidth)+_
					   "</option>"+vbCrLf
		Response.Write vbTab+vbTab+vbTab+"</select>"+vbCrLf
		
	End Sub

	Sub GenerateScriptNameSelectByQuery(TMSServerPtr, strSelected, _
										intSize, intWidth)
		' requires: intSize > 0, intWidth > 0
		' modifies: TMSServerPtr
		' effects:  This function generates a select list of scripts contained 
		'			in the data store pointed to by TMSServerPtr.  The 
		'			selected attribute will be set for any script with a name 
		'			matching strSelected.  The select list will display 
		'			intSize number of items and be intWidth wide.
		
		On Error Resume Next
		
		Dim TMSTestAssetTypePtr
		Dim TMSQueryPtr
		Dim vtType
		Dim TMSResultSetPtr
		Dim TMSScriptPtr
		Dim TMSTestScriptServerPtr
		Dim TMSCoreServerPtr
		Dim TMSSchemaPtr

		Dim intCounter
		Dim strName	
		Dim strAssetType
		Dim strSelectProperty
		Dim strFilterProperty
		Dim strFilterOperator
		Dim strSQLOperator
		Dim strVtType

		strAssetType = "TMS_ARTIFACT_TYPE_SCRIPT"
		strSelectProperty = "TMS_PROPERTY_TYPE_NAME"
		strFilterProperty = "TMS_PROPERTY_TYPE_SCRIPTTYPE"
		strFilterOperator = "TMS_FILTER_OPERATOR_EQUAL"
		strSQLOperator = "TMS_SQL_CONNECTOR_AND"
		strVtType = "TMS_SCRIPT_TYPE_NAME_MANUAL"


		' Generate the select input object.
		Response.Write vbCrLf
		Response.Write vbTab+vbTab+vbTab+_
					   "<select size='"+CStr(intSize)+"' name='ScriptNameList'"+_
					   " style='font-family: Courier; font-size: 9pt'>"+vbCrLf
					
		' Do a standard data store query for all objects of strAssetType
		
		Set TMSTestScriptServerPtr = TMSServerPtr.TestScriptServer
		If Err.Number <> 0 then	
			Exit Sub
		End if
		Set TMSCoreServerPtr = TMSTestScriptServerPtr.CoreServer
		If Err.Number <> 0 then	
			Exit Sub
		End if
		Set TMSSchemaPtr = TMSCoreServerPtr.Schema		
		If Err.Number <> 0 then	
			Exit Sub
		End if
		Set TMSTestAssetTypePtr = TMSSchemaPtr.GetTestAssetType(strAssetType)
		If Err.Number <> 0 then	
			Exit Sub
		End if
		Set TMSQueryPtr = TMSTestAssetTypePtr.CreateQuery()
		If Err.Number <> 0 then	
			Exit Sub
		End if
		Set vtType = strVtType
		TMSQueryPtr.AddSELECTProperty strSelectProperty, 0
		If Err.Number <> 0 then	
			Exit Sub
		End if
		TMSQueryPtr.AddFILTERRow strFilterProperty, strFilterOperator, vtType, 0, 0, strSQLOperator, 0
		If Err.Number <> 0 then	
			Exit Sub
		End if
		Set TMSResultSetPtr = TMSQueryPtr.Execute()
		If Err.Number <> 0 then	
			Exit Sub
		End if
		
		' Once we have the script objects, get all the names
		For intCounter = 1 To TMSResultSetPtr.Count	
			strName = TMSResultSetPtr.PropertyValue(intCounter - 1, _							
				  									strSelectProperty)											 
			If Err.Number <> 0 then	
				Exit Sub
			End if
			If strName = strSelected Then
				Response.Write vbTab+vbTab+vbTab+vbTab+_
							   "<option selected>"+_
							   strName+"</option>"+vbCrLf
			Else
				Response.Write vbTab+vbTab+vbTab+vbTab+_
							   "<option>"+strName+_
							   "</option>"+vbCrLf
			End If				
		Next

		' Hack the width of the netscape select box (YUCK!).
		'If BrowserIsNetscape Then
		'	intWidth = intWidth + 55
		'End If

		' Create a dummy select option that sets the size (Again, YUCK!).
		Response.Write vbTab+vbTab+vbTab+vbTab+_
					   "<option value=''>"+CreateWhiteSpace(intWidth)+_
					   "</option>"+vbCrLf
		Response.Write vbTab+vbTab+vbTab+"</select>"+vbCrLf		

	End Sub

	Sub GenerateBuildSelectByAssetCol(TMSServerPtr, strSelected, _
									  intSize, intWidth)	
		' requires: intSize > 0, intWidth > 0
		' modifies: TMSServerPtr
		' effects:  This function generates a select list of builds
		'			contained in the data store pointed to by TMSServerPtr.
		'           The selected attribute will be set for any build with 
		'           a name matching strSelected.  The select list will 
		'           display intSize number of items and be intWidth wide.
		
		On Error Resume Next
		
		Dim TMSAssetColPtr
		
		Dim intCounter
		Dim strName

		' Generate the select input object.
		Response.Write vbCrLf
		Response.Write vbTab+vbTab+vbTab+_
					   "<select size='"+CStr(intSize)+"' name='Build'"+_
					   " onChange='LogForm.submit();'" +_
					   " style='font-family: Courier; font-size: 9pt'>"+vbCrLf

		' Hack the width of the netscape select box (YUCK!).
		'If BrowserIsNetscape Then
		'	intWidth = intWidth + 55
		'End If

		' Grab all the builds from the project.
		Set TMSAssetColPtr = TMSServerPtr.Builds
		If Err.Number <> 0 then
			Exit Sub
		End if
		
		For intCounter = 1 To TMSAssetColPtr.Count
			If Err.Number <> 0 then
				Exit Sub
			End if
			strName = TMSAssetColPtr.Name(intCounter)
			If Err.Number <> 0 then
				Err.Description = "here1"	
				Exit Sub
			End if		
			' If a build is not chosen to be selected by default, then make the 
			' first build in the list the selected build.
			If strSelected = "" AND intCounter = 1 Then
				strSelected = strName
				Session("Build") = strSelected
			End If
			If strName = strSelected Then
				Response.Write vbTab+vbTab+vbTab+vbTab+_
							   "<option selected>"+_
							   strName+"</option>"+vbCrLf
			Else
				Response.Write vbTab+vbTab+vbTab+vbTab+_
							   "<option>"+strName+_
							   "</option>"+vbCrLf
			End If				
		Next
		' Create a dummy select option that sets the size (Again, YUCK!).
		Response.Write vbTab+vbTab+vbTab+vbTab+_
					   "<option value=''>"+CreateWhiteSpace(intWidth)+_
					   "</option>"+vbCrLf

		Response.Write vbTab+vbTab+vbTab+"</select>"+vbCrLf

	End Sub

	Sub GenerateLogFolderSelectbyAssetCol(TMSServerPtr, _
										  strBuild, strSelected, _
										  intSize, intWidth)
		' requires: intSize > 0, intWidth > 0
		' modifies: TMSServerPtr
		' effects:  This function generates a select list of log folders
		'			contained in the data store and build pointed to by 
		'			TMSServerPtr and strBuildPtr respectively.  The 
		'			selected attribute will be set for any log folder with a 
		'			name matching strSelected.  The select list will display 
		'			intSize number of items and be intWidth wide.

		' Generate the select input object.
		Response.Write vbCrLf
		Response.Write vbTab+vbTab+vbTab+_
					   "<select size='"+CStr(intSize)+"' name='LogFolder'"+_
					   " style='font-family: Courier; font-size: 9pt'>"+vbCrLf

		' Hack the width of the nextscape select box (YUCK!).
		'If BrowserIsNetscape Then
		'	intWidth = intWidth + 55
		'End If

		' If there is a build, grab the log folder collection from it.
		If strBuild <> Empty Then
			Dim TMSBuildPtr
			Dim TMSAssetColPtr
			Dim intCounter
			Dim strName
					
			Set TMSBuildPtr = TMSServerPtr.GetBuildByName(strBuild)
			If Err.Number <> 0 then
				Exit Sub
			End if
			Set TMSAssetColPtr = TMSBuildPtr.GetLogFolders
			If Err.Number <> 0 then
				Exit Sub
			End if
				
			' Once we have the log folder collection, get all the log folder 
			' names
			For intCounter = 1 TO TMSAssetColPtr.Count
				If Err.Number <> 0 then
					Exit Sub
				End if
				strName = TMSAssetColPtr.Name(intCounter)
				If Err.Number <> 0 then
					Exit Sub
				End if
				' If a log folder is not chosen to be selected by default, 
				' then make the first log folder in the list the selected 
				' log folder.		
				If strSelected = "" And intCounter = 1 Then
					strSelected = strName
					Session("LogFolder") = strSelected
				End If
				' Set the selected attribute for the log folder chosen to
				' be selected by default.
			If strName = strSelected Then
				Response.Write vbTab+vbTab+vbTab+vbTab+_
							   "<option selected>"+_
							   strName+"</option>"+vbCrLf
			Else
				Response.Write vbTab+vbTab+vbTab+vbTab+_
							   "<option>"+strName+_
							   "</option>"+vbCrLf
			End If				
			Next
		End If
		' Create a dummy select option that sets the size (Again, YUCK!).
		Response.Write vbTab+vbTab+vbTab+vbTab+_
					   "<option value=''>"+CreateWhiteSpace(intWidth)+_
					   "</option>"+vbCrLf

		Response.Write vbTab+vbTab+vbTab+"</select>"+vbCrLf
	End Sub

	Sub SetResultsAllPass

		On Error Resume Next	

	    Dim DataArray
		Dim strType
		Dim iCount

	    DataArray = Session("Data")

	    For iCount = 1 to UBound(DataArray,2)
			strType = DataArray(0, iCount)
			If strType = "STEP" Or strType = "Step" Then
				DataArray(3, iCount) = "on"
			End If
			If strType = "VP" Then
				DataArray(3, iCount) = "Pass"
			End If	
		Next

	    Session("Data") = DataArray

	End Sub

	Sub SetResultsAllEmpty

		On Error Resume Next	

	    Dim DataArray
		Dim strType
		Dim iCount

	    DataArray = Session("Data")

	    For iCount = 1 to UBound(DataArray,2)
			strType = DataArray(0, iCount)
			If strType = "STEP" Or strType = "Step" Then
				DataArray(3, iCount) = ""
			End If
			If strType = "VP" Then
				DataArray(3, iCount) = "None"
			End If
			DataArray(4, iCount) = ""
			DataArray(7, iCount) = ""
	    Next

	    Session("Data") = DataArray

	End Sub
%>