<%@ language = VBScript %> 
<%
' Copyright 1998-2001 Rational Software Corporation
'
'
'	File: write_log.asp
'
'	Modification History:
'	
'	Date		Who			What
'	6/21/99		PSun		Added modification history.
'							Added error checking.
'	6/22/99		PSun		Added internal input processing.
'							Added session timeout check
'	6/23/99		PSun		Added logging of steps and associated comments (WSBU00007628)
'	6/28/99		PSun		Fixed misalignment of Select Script button on Unix IE5.
'	7/30/99		PSun		Added logging for incomplete step as warning.
'							Changed timeout handling.
'	8/18/99		PSun		Added SessionID to window names.
'	8/23/99		PSun		Code cleanup.
'	11/30/99	PSun		Changed timeout handling.
'	7/20/00		PSun		Added changes to reflect new ML data store.
'	12/20/00	PSun		Changed load_script.asp target.
'	03/22/01	PSun		Modified logging to use new TSS.
'   	03/23/01	ALiberman	Modified logging to use new TSS. in TMSUI
'       0702/02         OMoroz		Added strNameText that will hold the first 64 characters of the Step or VP
'       	        		           text field.  This will be used as the "name" of the Step or VP
'       08/06/02        OMoroz          Added information about "Expected Result", "Expectd Result File", "Result Details",
'                                       and "Result Details File" to the log
'
%>
<!--#include file=./utilities/all.inc-->
<%
	On Error Resume Next

	Dim bContinue
	bContinue = true

	' All dialogs are called recursively to process different state
	' transitions.  They have the general form of the following three
	' function calls.
	'
	'		InitializeState
	'		ProcessInput
	'		DisplayOutput

	InitializeState
	If bContinue Then
		ProcessInput
		WriteLog
		DisplayOutput
	End If
	If CheckError Then
		ErrorDialog "Error Writing to Log", "Write to Another Log"
		Session("WriteLog") = Empty
		%>
		<script language='JavaScript'>
			window.close();
		</script>
		<%
	End If

	
	Sub InitializeState
		' requires:
		' modifies: Session variables.
		' effects:  Checks to make sure that the Session has not timed out.
		On Error Resume Next
		
		CheckTimeout
		SetSessionVariables
	End Sub

	Sub CheckTimeout
		' requires:
		' modifies:
		' effects:	Checks the pulse of the session.  If the session is 
		'			"dead", close the dialog.
		On Error Resume Next

		If Session("Alive") <> true Then
			%>
			<script language='JavaScript'>  
				window.open('session_timeout.asp','TestManager<%=Request.QueryString("SessionID")%>');
				window.close();
			</script>
			<%			
			bContinue = false
		End If
	End Sub

	Sub SetSessionVariables
		' requires:
		' modifies: 
		' effects:	
		On Error Resume Next
	End Sub
	
	Sub ProcessInput
		' requires:
		' modifies: Session variables.
		' effects:	Write the log.  Handles the input and deals with properly 
		'			setting the environment for the next state. 
		On Error Resume Next
		
		%>
		<script language='JavaScript'>
			var iScreenW = screen.width;
			var iScreenH = screen.height;
			var winChild;

			if (window.navigator.appName == 'Netscape') {
				iScreenW = window.outerWidth/2 + window.screenX - 50;
				iScreenH = window.outerHeight/2 + window.screenY - 50;
			}
		</script>
		<%
		If Request.QueryString("LoadScript") = "True" Then
			%>
			<script language='JavaScript'>
				winChild = window.open('','tm_content<%=Session("SessionID")%>');
				winChild.location.replace('load_script.asp');
				window.close();
			</script>
			<%
		ElseIf Request.QueryString("LogOff") = "True" Then
			%>
			<script language='JavaScript'>
				window.open('log_off.asp','TestManager<%=Session("SessionID")%>');
				window.close();	
			</script>
			<%
		End If
	End Sub

	Sub WriteLog
		' requires:
		' modifies: The log file specified by Session("Build"), 
		'			Session("LogFolder'), and Session("Log") 
		' effects:	Writes the results collected in Session("Data") to the
		'			log file.  Will write incomplete steps as warnings if
		'			the flag Session("StepAsWarning") is set.
		On Error Resume Next
	
		Dim TMSServerPtr
		Dim TMSBuildPtr
		Dim TMSLogFolderPtr
		Dim TMSLogPtr
		Dim TMSLogColPtr
		Dim TMSTestScriptServerPtr
		Dim TSSLogPtr
		Dim TSSSessionPtr
		Dim strBuildName
		Dim strLogFolderName
		Dim strLogName
		Dim strScriptName
		Dim strNameText
		Dim strAdditionalInfo
		Dim strResultDeatailsFile
		Dim strExpectedResult
		Dim strExpectedResultFile
		Dim strFailureDescription
		Dim strDatastorePath
		Dim strScriptSourceUID
		Dim strUserID
		Dim strTestCaseName
		Dim strTestCaseUID
		Dim strLogUID
		Dim bExit
		Dim bFoundFailure
		Dim bFoundPass
		Dim bFoundWarning
		Dim bNotCompleted
		Dim intResult
		Dim intCounter
		Dim intFailureReason
		Dim DataArray

		Dim NVStartNameArray
		Dim NVStartValueArray
		Dim NVTCStartNameArray
		Dim NVTCStartValueArray
		Dim NVVPNameArray
		Dim NVVPValueArray
		Dim NVStepNameArray
		Dim NVStepValueArray
		Dim NVEndNameArray
		Dim NVEndValueArray
		Dim NVTCEndNameArray
		Dim NVTCEndValueArray

		Set NVStartNameArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVStartValueArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVEndNameArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVEndValueArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVTCStartNameArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVTCStartValueArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVTCEndNameArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
		Set NVTCEndValueArray = Server.CreateObject("TMSServer.TMSVariantArray.1")

		strBuildName = Session("Build")
		strLogFolderName = Session("LogFolder")
		strLogName = Session("Log")
		strScriptName = Session("ScriptName")
		strUserID = Session("UserID")
		strTestCaseName = Session("TestCaseName")
		strTestCaseUID = Session("TestCaseUID")
		Set TMSServerPtr = Session("TMSServerPtr")
		If Err.number <> 0 Then
			Exit Sub
		End If		

		Set TMSBuildPtr = TMSServerPtr.GetBuildByName(strBuildName)
		If Err.number <> 0 Then
			Exit Sub
		End If
				
		Set TMSLogFolderPtr = TMSBuildPtr.GetLogFolder(strLogFolderName)
		If Err.number <> 0 Then
			Exit Sub
		End If

		Set TMSLogColPtr = TMSLogFolderPtr.GetLogs
		If Err.number <> 0 Then
			Exit Sub
		End If	
		Set TMSLogPtr = TMSLogFolderPtr.CreateLog
		If Err.number <> 0 Then
			Exit Sub
		End If

		Set TMSTestScriptServerPtr = TMSServerPtr.TestScriptServer
		If Err.number <> 0 Then
			Exit Sub
		End If
		
		strDatastorePath = TMSTestScriptServerPtr.DatastorePath
		If Err.number <> 0 Then
			Exit Sub
		End If
		 
		strScriptSourceUID = TMSServerPtr.GetRationalTestScriptSourceUID(strScriptName, strDatastorePath)
		If Err.number <> 0 Then
			Exit Sub
		End If
		
		' If the log exists, overwrite by loading it, otherwise create a new
		' log.
		bExist = false
		For intCounter = 1 to TMSLogColPtr.Count
			If TMSLogColPtr.Name(intCounter) = strLogName Then
				strLogUID = TMSLogColPtr.UID(intCounter)
				bExist = true
			End If
		Next


		If bExist = true Then
			TMSLogFolderPtr.DeleteLog(strLogUID)
			If Err.number <> 0 Then
				Exit Sub
			End If
			TMSLogPtr.Insert(strLogName)
			If Err.number <> 0 Then
				Exit Sub
			End If
		Else
			TMSLogPtr.Insert(strLogName)
			If Err.number <> 0 Then
				Exit Sub
			End If
		End If

		Set TSSSessionPtr =	Server.CreateObject("TMSUI.TMSTSSSessionProxy.1")
		If Err.number <> 0 Then
			Exit Sub
		End If		
			
		TSSSessionPtr.ServerStart
		If Err.number <> 0 Then
			Exit Sub
		End If		

		Dim strServerName 
		strServerName = Request.ServerVariables("SERVER_NAME")

		TSSSessionPtr.Connect "", 0
		If Err.number <> 0 Then
			Exit Sub
		End If		
		
		Dim strLogPath
		Dim strPath
		Dim intIndex
		Dim intLength
		Dim strName
		strLogPath = TMSLogPtr.PropertyValue("MasterLogFilePath")
		If Err.number <> 0 Then
			Exit Sub
		End If		
		
		intIndex = Len(strLogName + ".log")		
		intLength = Len(strLogPath)

		If intIndex <> 0 Then
			strPath = Left(strLogPath, intLength - intIndex)
			strName = Right(strLogPath, intIndex)				
		End If
		
		' Set Context
		TSSSessionPtr.Context 4, strPath
		TSSSessionPtr.Context 5, strName
		TSSSessionPtr.Context 9, strScriptSourceUID
		If Err.number <> 0 Then
			Exit Sub
		End If			
		
		Set TSSLogPtr =	Server.CreateObject("TMSUI.TMSTSSLogProxy.1")
		If Err.number <> 0 Then
			Exit Sub
		End If	

		NVTCStartNameArray.AddValue(SZ_TMS_PROPERTY_NAME_TESTCASE_NAME)
		NVTCStartValueArray.AddValue(strTestCaseName)
		NVTCStartNameArray.AddValue(SZ_TMS_PROPERTY_NAME_TESTCASE_UID)
		NVTCStartValueArray.AddValue(strTestCaseUID)
		If Err.number <> 0 Then
			Exit Sub
		End If	

		TSSLogPtr.GenericLogEvent TMS_LOG_EVENT_CATEGORY_ROBOT, _
								  TMS_LOG_EVENT_TYPE_TESTCASE_START, _
								  TMS_LOG_EVENT_RESULT_NONE, _
								  TMS_LOG_EVENT_FAILURE_REASON_NONE, _
								  "", _
								  NVTCStartNameArray, _
								  NVTCStartValueArray
		If Err.number <> 0 Then
			Exit Sub
		End If	
		
		NVStartNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_LINE_NUMBER)
		NVStartValueArray.AddValue("1")
		NVStartNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_NAME)
		NVStartValueArray.AddValue(strScriptName)
		NVStartNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_ID)
		NVStartValueArray.AddValue(strScriptName)
		NVStartNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_SOURCE_UID)
		NVStartValueArray.AddValue(strScriptSourceUID)
		If Err.number <> 0 Then
			Exit Sub
		End If	

		TSSLogPtr.GenericLogEvent TMS_LOG_EVENT_CATEGORY_ROBOT, _
								  TMS_LOG_EVENT_TYPE_SCRIPT_START, _
								  TMS_LOG_EVENT_RESULT_NONE, _
								  TMS_LOG_EVENT_FAILURE_REASON_NONE, _
								  "", _
								  NVStartNameArray, _
								  NVStartValueArray
		If Err.number <> 0 Then
			Exit Sub
		End If	

		DataArray = Session("Data")
		For intCounter = 1 to UBound(DataArray,2)
			If DataArray(0, intCounter) = "VP" Then
				If DataArray(3, intCounter) = "None" Then
					intResult = TSS_LOG_RESULT_NONE
				ElseIf DataArray(3, intCounter) = "Warn" Then
					intResult = TSS_LOG_RESULT_WARN	
					bFoundWarning = true				
				ElseIf DataArray(3, intCounter) = "Pass" Then
					intResult = TSS_LOG_RESULT_PASS
					bFoundPass = true
				ElseIf DataArray(3, intCounter) = "Fail" Then 
					intResult = TSS_LOG_RESULT_FAIL
					bFoundFailure = true
				End If
				
				strAdditionalInfo = DataArray(4,intCounter)
				strResultDetailsFile = DataArray(7, intCounter)
				strExpectedResult = DataArray(5, intCounter)
				strExpectedResultFile = DataArray(6, intCounter)
				strNameText = DataArray(1,intCounter)
				' strNameText will hold the first 64 characters of the Step or VP
				' text field.  This will be used as the 'name' of the Step or VP
				' in the log viewer.

				strNameText = Left(strNameText , 64)

				intFailureReason = TMS_LOG_EVENT_FAILURE_REASON_NONE
			
				If strAdditionalInfo = NULL Then
					strAdditionalInfo = ""
				End If
				If strResultDetailsFile = NULL Then
					strExpectedResultFile = ""
				End If
				If strExpectedResult = NULL Then
					strExpectedResult = ""
				End If
				If strExpectedResultFile = NULL Then
					strExpectedResultFile = ""
				End If
			
				Set NVVPNameArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
				Set NVVPValueArray = Server.CreateObject("TMSServer.TMSVariantArray.1")

				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_LINE_NUMBER)
				NVVPValueArray.AddValue(CStr(intCounter))
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_NAME)
				NVVPValueArray.AddValue(strScriptName)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_ID)
				NVVPValueArray.AddValue(strScriptName)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_SOURCE_UID)
				NVVPValueArray.AddValue(strScriptSourceUID)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_VERIFICATION_POINT_NAME)
				NVVPValueArray.AddValue(strNameText)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_VERIFICATION_POINT_TYPE)
				NVVPValueArray.AddValue(CStr(TMS_VP_TYPE_MANUAL))
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_EXPECTED_RESULT)
				NVVPValueArray.AddValue(strExpectedResult)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_EXPECTED_RESULT_FILE)
				NVVPValueArray.AddValue(strExpectedResultFile)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_RESULT_DETAILS)
				NVVPValueArray.AddValue(strAdditionalInfo)
				NVVPNameArray.AddValue(SZ_TMS_PROPERTY_NAME_RESULT_DETAILS_FILE)
				NVVPValueArray.AddValue(strResultDetailsFile)
				TSSLogPtr.GenericLogEvent TMS_LOG_EVENT_CATEGORY_ROBOT, _
										  TMS_LOG_EVENT_TYPE_VERIFICATION_POINT, _
										  intResult, _
										  intFailureReason, _
										  "", _
										  NVVPNameArray, _
										  NVVPValueArray
				If Err.number <> 0 Then
					Exit Sub
				End If	

			ElseIf DataArray(0, intCounter) = "Step" Then
				If DataArray(3, intCounter) = "on" Then
					intResult = TSS_LOG_RESULT_COMPLETED
				ElseIf CBool(Request.Cookies(strUserID)("StepAsWarning")) Then 
					intResult = TSS_LOG_RESULT_WARN
					bNotCompleted = true
				Else
					intResult = TSS_LOG_RESULT_NONE
					bNotCompleted = true
				End If
				
				strAdditionalInfo = DataArray(4,intCounter)
				strResultDetailsFile = DataArray(7,intCounter)
				strExpectedResult = DataArray(5,intCounter)
				strExpectedResultFile = DataArray(6,intCounter)
				' strNameText will hold the first 64 characters of the Step or VP
				' text field.  This will be used as the 'name' of the Step or VP
				' in the log viewer.
				strNameText = DataArray(1,intCounter)
				strNameText =Left(strNameText , 64)

				intFailureReason = TMS_LOG_EVENT_FAILURE_REASON_NONE			

				If strAdditionalInfo = NULL Then
					strAdditionalInfo = ""
				End If
				
				If strResultDetailsFile = NULL Then
					strResultDetailsFile = ""
				End If
				If strExpectedResult = NULL Then
					strExpectedResult = ""
				End If
				If strExpectedResultFile = NULL Then
					strExpectedResultFile = ""
				End If

				Set NVStepNameArray = Server.CreateObject("TMSServer.TMSVariantArray.1")
				Set NVStepValueArray = Server.CreateObject("TMSServer.TMSVariantArray.1")

				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_LINE_NUMBER)
				NVStepValueArray.AddValue(CStr(intCounter))
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_NAME)
				NVStepValueArray.AddValue(strScriptName)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_ID)
				NVStepValueArray.AddValue(strScriptName)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_SOURCE_UID)
				NVStepValueArray.AddValue(strScriptSourceUID)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_EXPECTED_RESULT)
				NVStepValueArray.AddValue(strExpectedResult)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_EXPECTED_RESULT_FILE)
				NVStepValueArray.AddValue(strExpectedResultFile)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_RESULT_DETAILS)
				NVStepValueArray.AddValue(strAdditionalInfo)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_RESULT_DETAILS_FILE)
				NVStepValueArray.AddValue(strResultDetailsFile)
				NVStepNameArray.AddValue(SZ_TMS_PROPERTY_NAME_MANUALSTEP_NAME)
				NVStepValueArray.AddValue(strNameText)				
				
				TSSLogPtr.GenericLogEvent TMS_LOG_EVENT_CATEGORY_ROBOT, _
										  TMS_LOG_EVENT_TYPE_MANUALSTEP, _
										  intResult, _
										  intFailureReason, _
										  "", _
										  NVStepNameArray, _
										  NVStepValueArray
				If Err.number <> 0 Then
					Exit Sub
				End If				
			End If			
		Next

		intResult = TSS_LOG_RESULT_NONE
		If bFoundFailure = true Then
			intResult = TSS_LOG_RESULT_FAIL
			intFailureReason = TMS_LOG_EVENT_FAILURE_REASON_NONE
		ElseIf bFoundWarning = true Then
			intResult = TSS_LOG_RESULT_WARN			
		ElseIf bFoundPass = true Then
			intResult = TSS_LOG_RESULT_PASS
		ElseIf bNotCompleted <> true Then
			intResult = TSS_LOG_RESULT_COMPLETED
		End If

		NVEndNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_LINE_NUMBER)
		NVEndValueArray.AddValue("1")
		NVEndNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_NAME)
		NVEndValueArray.AddValue(strScriptName)
		NVEndNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_ID)
		NVEndValueArray.AddValue(strScriptName)
		NVEndNameArray.AddValue(SZ_TMS_PROPERTY_NAME_SCRIPT_SOURCE_UID)
		NVEndValueArray.AddValue(strScriptSourceUID)
		
		TSSLogPtr.GenericLogEvent TMS_LOG_EVENT_CATEGORY_ROBOT, _
								  TMS_LOG_EVENT_TYPE_SCRIPT_END, _
								  intResult, _
								  intFailureReason, _
								  "", _
								  NVEndNameArray, _
								  NVEndValueArray
		If Err.number <> 0 Then
			Exit Sub
		End If	

		NVTCEndNameArray.AddValue(SZ_TMS_PROPERTY_NAME_TESTCASE_NAME)
		NVTCEndValueArray.AddValue(strTestCaseName)
		NVTCEndNameArray.AddValue(SZ_TMS_PROPERTY_NAME_TESTCASE_UID)
		NVTCEndValueArray.AddValue(strTestCaseUID)
		If Err.number <> 0 Then
			Exit Sub
		End If	

		TSSLogPtr.GenericLogEvent TMS_LOG_EVENT_CATEGORY_ROBOT, _
								  TMS_LOG_EVENT_TYPE_TESTCASE_END, _
								  intResult, _
								  intFailureReason, _
								  "", _
								  NVTCEndNameArray, _
								  NVTCEndValueArray
		If Err.number <> 0 Then
			Exit Sub
		End If	


		TSSSessionPtr.Shutdown
		If Err.number <> 0 Then
			Exit Sub
		End If							

		TSSSessionPtr.Disconnect 
		If Err.number <> 0 Then
			Exit Sub
		End If							
		TSSSessionPtr.ServerStop
		If Err.number <> 0 Then
			Exit Sub
		End If					
	
		Session("WriteLog") = true		
	End Sub

	Sub DisplayOutput
		' requires:
		' modifies: 
		' effects:	Generates the write log dialog prompting the user for
		'			the next action.
		%>
		<html>
		<head>
			<title>
				Logging Status
			</title>
			<style type='text/css'>
				td {font-family: Arial; font-size: 10pt} 
			</style>
			<script language='JavaScript'>
				window.blur();
			</script>
		</head>
		<body bgcolor='#c0c0c0'>
			<center>
			<form name='WriteLogForm' method='POST'>
			<table cellspacing='0' cellpadding='0' border='0'>
			<tr>	
				<td align='center'>
				<font face='Arial, Helvetica' size='-1'>
					Results successfully logged.
				</td>
			</tr>
			<tr>
				<td align='right' bgcolor='#c0c0c0'>
				<table cellspacing='0' cellpadding='5' border='0'>
				<tr>
				<br>
					<td align='left' bgcolor='#c0c0c0'>
					<input type='button' name='LogOff' value='    Log Off    ' 
					       onClick='window.open("write_log.asp?LogOff=True" + 
												"&SessionID=<%=Session("SessionID")%>",
												"WriteLog<%=Session("SessionID")%>");'
					       style='font-family: Arial; font-size: 9pt'>
					&nbsp; 
					</td>
					<td align='left' bgcolor='#c0c0c0'>
					<input type='button' name='SelectScript' value='Select Test Case' 
					       onClick='window.open("write_log.asp?LoadScript=True" + 
												"&SessionID=<%=Session("SessionID")%>",
												"WriteLog<%=Session("SessionID")%>");'
					       style='font-family: Arial; font-size: 9pt'>
					&nbsp;
					</td>
				</tr>
				</table>
				</td>
			</tr>		
			</table>
			</form>
			</center>
		</body>
		</html>

		<script language='JavaScript'>
			//if (window.navigator.appName == 'Netscape') {
				//var x = document.width + 20;
				//var y = document.height - 10;
			//	var x = document.width + 20;
			//	 y = document.height - 10;
					
			//} else {
				var x = document.WriteLogForm.LogOff.offsetWidth + document.WriteLogForm.SelectScript.offsetWidth + 75;
				var y = document.WriteLogForm.offsetHeight + 50;
			//}

			window.resizeTo(x,y);
			window.focus();

			var xMax;
			var yMax;
			var xOffset;
			var yOffset;
			if (window.navigator.appName == 'Netscape') {
				xMax = window.opener.outerWidth;
				yMax = window.opener.outerHeight;
				xOffset = (xMax - x)/2 + window.opener.screenX;
				yOffset = (yMax - y)/2 + window.opener.screenY;				
			} else {
				xMax = screen.width;
				yMax = screen.height;
				xOffset = (xMax - x)/2;
				yOffset = (yMax - y)/2;
			}
			window.moveTo(xOffset,yOffset);
		</script>
		<%
	End Sub
%>